
//[2009.04.13.][!!!]{---------------------------------------------------
//[н]  ǥ ű԰  Ѵ.
//
//[2009.07.11.][!!!]----------------------------------------------------
// [˵]   ǵ [Ĺ]   ǹǷ,  [GxCom] 
//[󱸵] ÿ ȴ.
//׷, ̰͵  [Ĺ]  üؾ Ѵ.
//}---------------------------------------------------------------------------


#include <vcl.h>
#pragma hdrstop


#include  "gxcom.h"


//------------------------------------------------------------------------------
//[MODE:0]----------------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall GxCom_M0_Encode(//  ġ.
                                unsigned char  *rPacketBuf,
                                unsigned char   pMsg)
{
  //[2009.04.13.][!!!]{-----------------------------------
  //[MODE:0]  Ѵ.
  // 1Byte  ̷ Ƿ ϰ ó Ҽ ִ.
  //
  //[]------------------------------------------------------
  //
  //  |<--<8BIT>-->|
  //     4       4
  //{ [MODE:0][ڷ] }  <---1Byte ũ.
  //
  //}-----------------------------------------------------------

  //1Byte  ԼѴ.
  rPacketBuf[0] = (d_GxCom_Mode_0 << 4) | (pMsg & 0x0f);

  return;

}

int __fastcall GxCom_M0_AckWrite(//[  ] ġ.
                                 unsigned char  *rPacketBuf)
{
  //[2009.04.13.][!!!]{------
  //<ACK>  Ѵ.
  //[MODE:0]  1Byte  Ѵ.
  //}------------------------------

  GxCom_M0_Encode(rPacketBuf, d_GxCom_M0_Ack);

  //ü ũ⸦ ȯѴ.
  return(1);

}

bool __fastcall GxCom_M0_AckRead(//[  ] ġ.
                                 unsigned char  *pPacketBuf)
{
  //[2009.04.13.][!!!]{------
  //<ACK>  ϴ ȮѴ.
  //[MODE:0]  1Byte  Ѵ.
  //}------------------------------

  if((pPacketBuf[0] & 0x0f) == d_GxCom_M0_Ack) { return(true);  }
  else                                         { return(false); }

}

//------------------------------------------------------------------------------
//[MODE:1]----------------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall GxCom_M1_Hdr_Encode(//[]    ġ.
                                    unsigned char   *rHdr,
                                    //[]  ռ .
                                    unsigned char    pAdrData,
                                    unsigned char    pWrRd,
                                    unsigned short   pSize)
{
  //[2009.04.13.][!!!]{----------------------------------------------------------
  //16Bit ũ []  .
  //
  //[!!!]--------------------------------------------------------------------------
  // Byte  µǾ ϹǷ  1 Byte   ȯ ־ Ѵ.
  //<*(short *)>   ȯϴ  <LittleEndian>  Ư  Byte
  //  µǰ ǹǷ Ѵ.
  //}----------------------------------------------------------------------------------

  //[16Bit   ]--------------------------
  //[BIT]  15 :  12    11       10     9  :   0
  //[   ]  [ MODE ]  [ A/D ]  [ W/R ]  [ ũ ]
  //}-----------------------------------------------

  //[VAR]
  //{
      //16Bit []  ϴ ⿡ Ѵ.
      unsigned short  hdr = 0;

  //}

  //[  ռ]
  //{
      hdr = ((d_GxCom_Mode_1 & d_GxCom_M1_Hdr_Mask_Mode)    << d_GxCom_M1_Hdr_Bit_Mode)    |
            ((pAdrData       & d_GxCom_M1_Hdr_Mask_AdrData) << d_GxCom_M1_Hdr_Bit_AdrData) |
            ((pWrRd          & d_GxCom_M1_Hdr_Mask_WrRd)    << d_GxCom_M1_Hdr_Bit_WrRd)    |
            ((pSize          & d_GxCom_M1_Hdr_Mask_Size)    << d_GxCom_M1_Hdr_Bit_Size);

  //}

  //[ȯ]
  //{
      // [ ]  ġ ̹Ƿ ֻ Byte  ȯѴ.
      rHdr[0] = (hdr >> 8) & 0xff; // Byte ġ.
      rHdr[1] = (hdr >> 0) & 0xff; // Byte ġ.

  //}

  return;

}

void __fastcall GxCom_M1_Hdr_Decode(//[]  ִ һ ġ.
                                    unsigned char   *pHdr,
                                    //[]  йȯ .
                                    //NULL ƴ 츸 ȯѴ
                                    unsigned char   *rAdrData,
                                    unsigned char   *rWrRd,
                                    unsigned short  *rSize)
{
  //[2009.04.14.ȭ][!!!]{---------------------------------
  //16Bit ũ []  мϿ   ´.
  //}---------------------------------------------------------

  //[16Bit   ]--------------------------
  //[BIT]  15 :  12    11       10     9  :   0
  //[   ]  [ MODE ]  [ A/D ]  [ W/R ]  [ ũ ]
  //}-----------------------------------------------

  //[VAR]
  //{
      //16Bit []  ϴ ⿡ Ѵ.
      unsigned short  hdr = 0;

  //}

  //[  ռ]
  //{
      //[]  2Byte ũ⸦ ´.
      hdr = (pHdr[0] << 8) & 0xff00;
      hdr = (pHdr[1] << 0) & 0x00ff;

  //}

  //[ /ȯ]
  //{
      if(rAdrData != NULL) { (*rAdrData) = (hdr >> d_GxCom_M1_Hdr_Bit_AdrData) & d_GxCom_M1_Hdr_Mask_AdrData; }

      if(rWrRd != NULL)    { (*rWrRd)    = (hdr >> d_GxCom_M1_Hdr_Bit_WrRd)    & d_GxCom_M1_Hdr_Mask_WrRd;    }

      if(rSize != NULL)    { (*rSize)    = (hdr >> d_GxCom_M1_Hdr_Bit_Size)    & d_GxCom_M1_Hdr_Mask_Size;    }

  //}

  return;

}

void __fastcall GxCom_M1_AdrPacket(//[ּŹ]    ġ.
                                   unsigned char  *rPacketBuf,
                                   //[/б] .
                                   unsigned char   pWrRd,
                                   //[/б] ũ.
                                   unsigned short  pSize,
                                   //[ּ] .
                                   unsigned char   pAdr)
{
  //[2009.04.13.][!!!]{-------
  //[ּŹ] κ ռѴ.
  //ٷ Ҽ ֵ .
  //}-------------------------------

  //[ ]
  //{
      GxCom_M1_Hdr_Encode(rPacketBuf, d_GxCom_M1_Adr, pWrRd, pSize);

  //}

  //[ּ  ߰]
  //{
      //[ּ]  <index:2> ġ Ѵ.
      rPacketBuf[2] = pAdr;

  //}

  return;

}

void __fastcall GxCom_M1_AdrPacket_Decode(//[ּŹ]    ġ.
                                          unsigned char   *pPacketBuf,
                                          //[]  йȯ .
                                          //NULL ƴ 츸 ȯѴ
                                          unsigned char   *rWrRd,
                                          unsigned short  *rSize,
                                          unsigned char   *rAdr)
{
  //[2009.04.14.ȭ][!!!]{----------------
  //[ּŹ]  ߿ Ѵ.
  //}----------------------------------------

  //[16Bit   ]--------------------------
  //[BIT]  15 :  12    11       10     9  :   0
  //[   ]  [ MODE ]  [ A/D ]  [ W/R ]  [ ũ ]
  //}-----------------------------------------------

  //[VAR]
  //{
      //16Bit []  ϴ ⿡ Ѵ.
      unsigned short  hdr = 0;

  //}

  //[ ]
  //{
      //[]    ⼭ Ѵ.
      GxCom_M1_Hdr_Decode(pPacketBuf, NULL, rWrRd, rSize);

  //}

  //[ּ ]
  //{
      //[ּ]  []   Ƿ  Ѵ.
      //[Ź]  <index:2>  1Byte  ּҰ ȴ.
      if(rAdr != NULL) { (*rAdr) = pPacketBuf[2]; }

  //}

  return;

}

int __fastcall GxCom_M1_DataPacket_Write(//[ڷŹ]    ġ.
                                         unsigned char  *rPacketBuf,
                                         //[/б] ũ.
                                         unsigned short  pSize,
                                         // ڷġ.
                                         unsigned char  *pStream)
{
  //[2009.04.13.][!!!]{--------------------
  //[ڷŹ] κ ռѴ.
  //ٷ Ҽ ֵ ü ռϿ .
  //}--------------------------------------------

  //[ ]
  //{
      GxCom_M1_Hdr_Encode(rPacketBuf, d_GxCom_M1_Data, d_GxCom_M1_Wr, pSize);

  //}

  //[ڷ ߰]
  //{
      //[ڷ] κ pSize ŭ pStream ġ о ռѴ.
      //[ּ]  <index:2> ġ Ѵ.
      memmove(&(rPacketBuf[2]), pStream, pSize);

  //}

  //ü ũ⸦ ȯѴ([ 2Byte]  ũ).
  return(2 + pSize);

}

void __fastcall GxCom_M1_DataPacket_Read(//[ڷŹ]   ִ ġ.
                                         unsigned char  *pPacketBuf,
                                         //о ڷḦ  ġ.
                                         unsigned char  *rStream)
{
  //[2009.04.13.][!!!]{--------------------
  //[ڷŹ] κ ռѴ.
  //ٷ Ҽ ֵ ü ռϿ .
  //}--------------------------------------------

  //[VAR]
  //{
      unsigned short  hdr = 0;
      unsigned short  size;

  //}

  //[ ]
  //{
      //16Bit []  ´.
      hdr = (pPacketBuf[0] << 8) | (pPacketBuf[1]);

  //}

  //[ ũ ]
  //{
      //  о ڷ [ũ]  ´.
      size = (hdr >> d_GxCom_M1_Hdr_Bit_Size) & d_GxCom_M1_Hdr_Mask_Size;

  //}

  //[ڷ ߰]
  //{
      //[ڷ] κ pSize ŭ pStream ġ о ռѴ.
      //[ּ]  <index:2> ġ Ѵ.
      memmove(rStream, &(pPacketBuf[2]), size);

  //}

  return;

}

bool __fastcall GxCom_M1_Is_AdrPacket(//[Ź]   ִ ġ.
                                      unsigned char  *pPacketBuf)
{
  //[2009.04.13.][!!!]{-------------------
  //[Ź]  [ּŹ]  ȮѴ.
  //}-------------------------------------------

  //[VAR]
  //{
      unsigned short  hdr = 0;

  //}

  //[ ]
  //{
      //16Bit []  ´.
      hdr = (pPacketBuf[0] << 8) | (pPacketBuf[1]);

  //}

  if(((hdr >> d_GxCom_M1_Hdr_Bit_AdrData) & d_GxCom_M1_Hdr_Mask_AdrData) == d_GxCom_M1_Adr) return(true);

  // ° ش ʴ°̴.
  return(false);

}

bool __fastcall GxCom_M1_Is_DataPacket(//[Ź]   ִ ġ.
                                       unsigned char  *pPacketBuf)
{
  //[2009.04.13.][!!!]{-------------------
  //[Ź]  [ڷŹ]  ȮѴ.
  //}-------------------------------------------

  //[VAR]
  //{
      unsigned short  hdr = 0;

  //}

  //[ ]
  //{
      //16Bit []  ´.
      hdr = (pPacketBuf[0] << 8) | (pPacketBuf[1]);

  //}

  if(((hdr >> d_GxCom_M1_Hdr_Bit_AdrData) & d_GxCom_M1_Hdr_Mask_AdrData) == d_GxCom_M1_Data) return(true);

  // ° ش ʴ°̴.
  return(false);

}

//------------------------------------------------------------------------------
//[MODE:2]----------------------------------------------------------------------
//------------------------------------------------------------------------------

//[2009.04.18.][߰!!!]{---------------------------
//[MODE:2]  []  Ͽ Ǵ ̴.
//[MODE:0]   ϰ ȴ.
//}---------------------------------------------------

void __fastcall GxCom_M2_Encode(//  ġ.
                                unsigned char  *rPacketBuf,
                                unsigned char   pMsg)
{
  //[2009.04.18.][!!!]{-----------------------------------
  //[MODE:2]  Ѵ.
  // 1Byte  ̷ Ƿ ϰ ó Ҽ ִ.
  //
  //[]------------------------------------------------------
  //
  //  |<--<8BIT>-->|
  //     4       4
  //{ [MODE:2][ڷ] }  <---1Byte ũ.
  //
  //}-----------------------------------------------------------

  //1Byte  ԼѴ.
  rPacketBuf[0] = (d_GxCom_Mode_2 << 4) | (pMsg & 0x0f);

  return;

}

int __fastcall GxCom_M2_BreakWrite(//[  ] ġ.
                                   unsigned char  *rPacketBuf)
{
  //[2009.04.18.][!!!]{------
  //<BREAK>  Ѵ.
  //[MODE:2]  1Byte  Ѵ.
  //}------------------------------

  GxCom_M2_Encode(rPacketBuf, d_GxCom_M2_Break);

  //ü ũ⸦ ȯѴ.
  return(1);

}

bool __fastcall GxCom_M2_BreakRead(//[  ] ġ.
                                   unsigned char  *pPacketBuf)
{
  //[2009.04.18.][!!!]{-------
  //<BREAK>  ϴ ȮѴ.
  //[MODE:2]  1Byte  Ѵ.
  //}-------------------------------

  if((pPacketBuf[0] & 0x0f) == d_GxCom_M2_Break) { return(true);  }
  else                                           { return(false); }

}

int __fastcall GxCom_M2_ErrorWrite(//[  ] ġ.
                                   unsigned char  *rPacketBuf)
{
  //[2009.05.10.][!!!]{------
  //<Error>  Ѵ.
  //[MODE:2]  1Byte  Ѵ.
  //}------------------------------

  GxCom_M2_Encode(rPacketBuf, d_GxCom_M2_Error);

  //ü ũ⸦ ȯѴ.
  return(1);

}

bool __fastcall GxCom_M2_ErrorRead(//[  ] ġ.
                                   unsigned char  *pPacketBuf)
{
  //[2009.05.10.][!!!]{-------
  //<Error>  ϴ ȮѴ.
  //[MODE:2]  1Byte  Ѵ.
  //}-------------------------------

  if((pPacketBuf[0] & 0x0f) == d_GxCom_M2_Error) { return(true);  }
  else                                           { return(false); }

}



































