//---------------------------------------------------------------------------

#ifndef ide_editorH
#define ide_editorH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
//---------------------------------------------------------------------------


#include "font.h"

#include "gui_page.h"
#include "gui_scroll_v.h"
#include "gui_scroll_h.h"
#include "gui_edgebox.h"

//[2010.02.22.][߰!!!]
#include  "GDotMatrix.h"

class Tide_editor_Form : public TForm
{
__published:	// IDE-managed Components

        void __fastcall FormResize(TObject *Sender);
        void __fastcall FormShow(TObject *Sender);

private:	// User declarations
public:		// User declarations

        __fastcall Tide_editor_Form(TComponent* Owner);

        //[2012.04.29.][Ϸ!!!]
        __fastcall ~Tide_editor_Form(void);

        //[Ŭ]
        //{
            //[2012.06.07.][Ϸ!!!]
            void __fastcall WndProc(Messages::TMessage &Message);

        //}

        //[VAR]
        //{
            //[ȯ溯]
            //{
                //[2007.10.02.ȭ][߰!!!]
                struct  IDE_OPTION   *_ide_option;

            //}

            //[ Ʈ]
            //{
                Tgui_page_Form        *_page_Form;
                Tgui_scroll_v_Form    *_scroll_v_Form;
                Tgui_scroll_h_Form    *_scroll_h_Form;
                Tgui_edgebox_Form     *_edgebox_Form;

            //}

        //}

        //[]
        //{
            //[VAR]
            //{
                //[2010.02.22.][߰!!!]
                //[]  Ư   ̴.
                TGDotMatrix_Form  *_GDotMatrix;

            //}

            //[2018.02.16.][Ϸ!!!]
            void __fastcall _GDotMatrix_Str(void);

            //[2010.02.22.][Ϸ!!!]
            void __fastcall _GDotMatrix_Color(void);

            //[2018.03.04.][Ϸ!!!]
            void __fastcall _GDotMatrix_ReSize(void);
            
            //[2018.03.04.][Ϸ!!!]
            void __fastcall _GDotMatrix_BackBmpChange(void);

            //[2018.03.04.][Ϸ!!!]
            void __fastcall _GDotMatrix_Use(//[2018.02.17.][߰!!!]
                                            //ϴ  true.
                                            bool  pUse);

            //[2018.02.17.][Ϸ!!!]
            void __fastcall _GDotMatrix_Rotate(//[2018.02.17.][߰!!!]
                                               //ϴ  true.
                                               bool  pRotate);

            //[2010.04.06.ȭ][Ϸ!!!]
            void __fastcall _GDotMatrix_RotateTemp(bool  pRotate);

            //[2010.04.09.][Ϸ!!!]
            void __fastcall _GDotMatrix_RotateTemp2(bool  pRotate);

        //}

        //[FUNCTION]
        //{
            //[2007.03.25.][Ϸ!!!]
            void __fastcall _Resize(void);

            void __fastcall _Split_v(void);
            void __fastcall _Split_h(void);

            //[2010.04.09.][Ϸ!!!]
            void __fastcall _Enable(bool  pENABLE);
            
        //}

        //[EVENT FUNCTION]
        //{
            //[2006.11.28.ȭ][Ϸ!!!]
            void __fastcall _EVENT_V_Scroll(void);
            void __fastcall _EVENT_V_MouseDown(void);
            void __fastcall _EVENT_H_Scroll(void);
            //[2007.04.05.][Ϸ!!!]
            void __fastcall _EVENT_H_MouseDown(void);

            void __fastcall _EVENT_PageUp(void);
            void __fastcall _EVENT_PageDown(void);
        //}

        //[Լ]
        //{
            //[2007.12.01.][Ϸ!!!]
            void __fastcall _RUN_Line(int  pLINEnumber);

            //[2007.12.01.][Ϸ!!!]
            void __fastcall _Line_View(int  pLineNumber);

            //[2022.06.28.ȭ][Ϸ]
            void __fastcall _Shape(void);

        //}

};

//---------------------------------------------------------------------------
extern PACKAGE Tide_editor_Form *ide_editor_Form;
//---------------------------------------------------------------------------

#endif
