
#include <vcl.h>
#pragma hdrstop


#include "main.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
Tmain_Form *main_Form;
//---------------------------------------------------------------------------

//[BuildTool ]
//{
    //[2022.09.14.][߰]{------------------------------------------------------------------
    //[˵-IDE] ۵ <TC++2006>  <ECB/CE>  ϴ ǰ  ִ.
    //
    // <BuildToolDefine.h>  Ʒ   ٸǷ <TC++2006>  ϴ 
    //<ECB/CE>  ϴ   ϰ  ־ Ѵ.
    //
    //#define  d_BuildTool_TC2006    true   <=== <TC++2006>  Ǵ   .
    //#define  d_BuildTool_TC2006    false  <=== <ECB/CE>  Ǵ   .
    //
    //[]----------------------------------------------------------------------------------
    //<TC++2006> : Turbo C++ 2006 Explorer
    //<ECB/CE>   : Embarcadero C++Builder/Community Edition
    //}---------------------------------------------------------------------------------------

    #include "BuildToolDefine.h"

//}

//[ӽ ]
//{
    #include "c_define.h"

    #include "ide_library.h"
    #include "library.h"
    #include "database.h"
    #include "font.h"
	#include "file.h"
	#include "gui.h"

    #include "compiler.h"
    #include "parser.h"
    #include "asmencoder.h"
    #include "object1st.h"
    #include "object.h"

    //[2009.03.12.][߰!!!]
    #include "vmos.h"

    //[2009.04.06.][߰!!!]
    #include "vdebug.h"

//}

#include "ide_main.h"
#include "ide_submenu.h"
#include "ide_msgbox.h"
#include "msg_msg.h"
#include "editor_top.h"
#include "editor_edit.h"
#include "ide_popup.h"

#include "editor_edit.h"

#include "ide_editor.h"

//[2010.12.06.ȭ][߰!!!]
#include "file_ginf.h"

//[2010.12.10.][߰!!!]
#include "vmos_info.h"

#include "math.h"

//[2012.05.23.][߰!!!]
#include "info_tree.h"

//[2018.05.05.][߰!!!]
#include "ide_buttons.h"


//[DATABASE]
//{
    //[!]{----------------------------------------
    //{DATABASE}  ü ּҰ  pointer.
    //test   뵵  Ѵ.
    //}-------------------------------------------

    class DATABASE  *_Pdatabase;

//}

__fastcall Tmain_Form::Tmain_Form(TComponent* Owner)
        : TForm(Owner)
{
  //[VAR]
  //{
      struct  IDE_OPTION    *ide_Option;

  //}

  //[Ÿ]
  //{
      //[2012.06.05.ȭ][߰!!!]
      _swResize = true;

  //}

  //[ ̸ ]
  //{
      //[2018.10.15.][߰!!!]{-----------------------------------------------------
      //[]  [׸ǰ]   [â]  ߰Ǿ [۾ǥ] 󿡼
      //  ʿϹǷ [˵-IDE]    "IDE"  "[˵-IDE]" 
      //̸ Ѵ.
      //}-----------------------------------------------------------------------------
      
      Application->Title = "˵-IDE";

  //}

  //[ġ]{------------
  //[2009.04.20.][߰!!!]
  IDE_Get_Option(&ide_Option);

  //[ȯ漳 ʱȭ]----------
  //[2010.07.05.][߰!!!]
  Ide_Option_Init();
  //}--------------------------

  //[Database ּ ]
  //{
      //[2005.08.29.][߰!!!]{--------------------------------------
      //{DATABASE} ü ּҰ ´.
      //{DATABASE}  ̹ parser.c ȿ ̹    ִ.
      //}--------------------------------------------------------------

      DATABASE_GetPtr(&_Pdatabase);

  //}

  //[  ]
  //{      
      //[2005.09.06.ȭ][߰!!!]{-------------------------------------------
      //{DATABASE}     θ  ش.
      //*.exe   ڸ ݵ θ  ƾ Ѵ.(ſ ߿)
      //}-------------------------------------------------------------------

	  STR_Assign(_Pdatabase->programpath, ((AnsiString)ExtractFilePath(Application->ExeName)).c_str());

      //[2005.09.20.ȭ][߰!!!]{------------------------------
      //ϴ IDE   ġ *.exe  ִ  Ѵ.
      //}------------------------------------------------------

	  STR_Assign(_Pdatabase->compilerpath, ((AnsiString)ExtractFilePath(Application->ExeName)).c_str());

      //[2005.10.07.][߰!!!]{------------------------------
      //ϴ IDE   ġ *.prj  ִ  Ѵ.
      //}------------------------------------------------------

	  STR_Assign(_Pdatabase->projectpath, ((AnsiString)ExtractFilePath(Application->ExeName)).c_str());

      //[2006.06.07.][߰!!!]{------------------------
      //*.prj  ġ  "Build"  ־ Ѵ.
      // θ  ش.
      //}------------------------------------------------

      STR_Assign(_Pdatabase->buildpath, _Pdatabase->projectpath);
      STR_Add_AB(_Pdatabase->buildpath, _Pdatabase->buildpath, "\\build\\");

  //}

  //[۲ ҽ ]
  //{
      //[!]{-----------------------------------------------------------------------
      // α׷  [۲]   о 鿩 [۲ ҽ]  .
      //׻ ϴ ڿ̹Ƿ α׷ ۰ ÿ ҷ 鿩 Ѵ.
      //}--------------------------------------------------------------------------

      FONTRESOURCE_Load();

  //}

  //[ũ]
  //{
      //[!]{-----------------------------------------------------------------
      //ִȭ Ʒ ۾ ǥ  ʵ  ִ ũ⸦ Ѵ.
      //Ʒ Ʈ̿  ȭ ̰ Ѵ.
      //}--------------------------------------------------------------------

      this->Constraints->MaxHeight = Screen->WorkAreaHeight;

  //}
  
  //[temp  ]
  //{
      //[2010.04.06.ȭ][߰!!!]{--------------------------------------------
      //ڰ Ҽ Ƿ IDE  Ҷ <temp>  <temp\gui_temp>
      //ΰ    ش.
      //}--------------------------------------------------------------------

      Ide_Make_TempFolder();

  //}

  //[ȯ溯 ]
  //{
      //[2007.10.02.ȭ][߰!!!]{---------------------
      //ȯ溯   о ٽ  Ѵ.
      //}---------------------------------------------

      IDE_OptionFile_Open();

  //}

  //[IDE:GUI ]
  //{
      IDE_CreateForms();

  //}    

  //[AlphaBlend ]
  //{
      //[2007.03.25.]
      this->AlphaBlend      = ide_Option->alphaBlendUse;
      this->AlphaBlendValue = ide_Option->alphaBlendValue;

  //}

  //[ü  ü ʱȭ]
  //{
      //[2010.12.10.][߰!!!]{-------
      //ݵ ѹ ʱȭ ؾ Ѵ.
      //}-------------------------------

      VmosInfo_Init();

  //}

  //[IDE:ΰó]
  //{
      //[2022.06.07.ȭ][߰]{-----------------------------------------
      //[˵-IDE] ۽  ⺻ ,  .
      //
      //ϴ, <IDE\glib\def_file.glist>  ϱ Ͽ ߰ϴ°.
      //}--------------------------------------------------------------

      IDE_StartUp_Etc();

  //}

  //[ Լ ʱȭ]
  //{
      //[2021.03.29.][߰]
      GIGYENICS_GUI_Test_Init();

  //}

}

__fastcall Tmain_Form::~Tmain_Form(void)
{
  //[Ҹ]

  //[⼭ ó ʴ´!!!]
  //{
      //[2010.03.08.][߿!!!]{-------------------------------------------------
      //Ʒ ΰ Լ  ⼭ óϸ ȵȴ.
      //<ide_main.cpp>  IDE_Close() Լȿ main_Form->Close() 
      // ó ־ Ѵ.
      //̷   <GVmos>    ʾƼ <IDE>   ϴ
      // ߻Ѵ.
      //}-----------------------------------------------------------------------------

      /*
      //[VMOS Thread ]
      //{
          //[2009.03.16.][߰!!!]{--------------
          //  [VMOS Thread]  Ѵ.
          //}--------------------------------------

          VMOS_ThreadDelete();

      //}

      //[VDEBUG Thread ]
      //{
          //[2009.04.06.][߰!!!]{----------------
          //  [VDEBUG Thread]  Ѵ.
          //}----------------------------------------

          VDEBUG_ThreadDelete();

      //}
      */

  //}

  FONTRESOURCE_Init();

  //    Ѵ.
  IDE_DeleteForms();

  //[׸ǰ]
  //{
      //[2010.02.10.][߿߰!!!]{---------------------------------
      //<Application>  ü   ⼭ ϸ ȵȴ.
      //ڵ ǹǷ ׳ θ ȴ.
      //}-------------------------------------------------------------

      //[2010.01.28.][߰!!!]{-------------------------
      //[]   [ ׸ǰ]  Ѵ.
      //GPART_GBalloonBox_Delete();
      //[]   [ Ͷ主]  Ѵ.
      //GPART_GHint_Delete();
      //}-------------------------------------------------

      //[2010.02.03.][߰!!!]{-----------------------
      //[]   [ ˸â]  Ѵ.
      //GPART_GMsgBox_Delete();
      //}-----------------------------------------------

      //[2010.02.07.][߰!!!]{------------------------
      //[]   [ãȭ]  Ѵ.
      //GPART_GFindDialog_Delete();
      //}------------------------------------------------

      //[2010.02.04.][߰!!!]{---------------
      //[⺻ȯ]    Ѵ.
      //GPART_GVmos_Delete();
      //}---------------------------------------

  //}

  return;

}

//------------------------------------------------------------------------------
//[Ŭ]------------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall Tmain_Form::WndProc(Messages::TMessage  &Message)
{
  switch(Message.Msg)
  {
    case WM_ERASEBKGND :
    {
      //[!]{----------------------------------------------------------------------------
      //ٷ շ  WM_ERASEBKGND ޼  TForm::WndProc(Message); 
      //ٽ ó Ǿ TForm->Color  ĥ Ǿ _Draw()  ׸   Ƿ
      //ٷ Ѵ.
      //
      //[2012.06.07.][!!!]--------------------------------------------------------
      //̴ κ   [ٽ ׸]  ʿ䰡 .
      //ִ [׸] ð ϱ Ѱ.
      //}-------------------------------------------------------------------------------

      return;

    } break;

    case WM_MOVING :
    {


    } break;

    case WM_MOVE :
    {


    } break;

    case WM_SIZE :
    {
      //[2006.10.15.][!!!]{---------------------------
      // [Ʈ]  ũ⸦ ٽ  ش.

      //[2007.03.18.][!!!]----------------------------
      //FormResizeEvent  ⼭ óϴ  Ѵ.
      //}---------------------------------------------------

     _Resize();

      return;

    } break;

  }

  //[⺻ó]
  //{
      //⺻ ޼ ݵ ó Ǿ Ѵ.
      TForm::WndProc(Message);
  //}

  return;

}

//------------------------------------------------------------------------------
//[óԼ]--------------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall Tmain_Form::_Resize(void)
{
  //[2006.12.15.][!!!]{-------------------------------------------
  // ũⰡ ϴ  ϰ ִ   ũ⸦ ٲپ ش.
  //
  //[2012.06.05.ȭ][!!!]--------------------------------------------
  //[˵-հȯ] ũ  [ߺ ó]  κ ߰.
  //}-------------------------------------------------------------------

  //[޴]  ޴  ʰ .
  if(ide_menu_Form != NULL)
  {
    ide_menu_Form->_SubMenu_Hide();
    ide_menu_Form->_Menu2();

    //[:߱]
    //{
        //[2012.05.23.][߰!!!]{-----------------
        //ܻ  ʵ ݵ   ó.
        //}-----------------------------------------

        if(info_tree_Form != NULL)
        {
          if(info_tree_Form->Visible == true) { info_tree_Form->Visible = false; }

        }

    //}

  }

  //[ߺ ]
  //{
      //[2012.06.05.ȭ][߰!!!]{-------------------------------------------------
      //[˵-հȯ] ũ  [/]  ι
      //ü ũ  ̷    Ͽ  ѹ
      //óϵ Ѵ.
      // <Tide_caption_Form::FormMouseUp()> ȿ <_swResize>  ȴ.
      //}-------------------------------------------------------------------------

      if(_swResize == true) { IDE_ResizeForms(); }
      
  //}
  
  return;

}

void __fastcall Tmain_Form::IDE_Test(void)
{
  //   Լ.

  //...

  return;

}

//------------------------------------------------------------------------------
//[Ʈ]----------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall Tmain_Form::ComM0_Txd(void)
{
  //[2009.04.13.][!!!]{---------------------
  //[MODE:0]  [۽ ]   Ѵ.
  //}---------------------------------------------

  //[VAR]
  //{
      class VMOS   *vmos;

  //}

  //[VMOSCOM ּҾ]{---
  VMOS_GetPtr(&vmos);
  //}---------------------

  //[]
  //{
      // [ ]  Ѵ.
      vmos->ComM0_Rxd(comM0_TxdBuf, comM0_TxdCount);

  //}

  //[ó]
  //{
      // ϿǷ ش.
      comM0_TxdCount = 0;

  //}

  return;

}

void __fastcall Tmain_Form::ComM0_Rxd(// .
                                      DTU1  *pBuf,
                                      // .
                                      DTU2   pCount)
{
  //[2009.04.13.][!!!]{------------------------------------
  //[MODE:0]  [ ]   Է   Ѵ.
  //}------------------------------------------------------------

  //[]
  //{
      //[ ] Ѵ.
      memmove(comM0_RxdBuf, pBuf, pCount);

  //}

  //[ó]
  //{
      //[ ]  Ű Ѵ.
      comM0_RxdCount = pCount;

  //}

  return;

}

void __fastcall Tmain_Form::ComM1_Txd(void)
{
  //[2009.04.12.][!!!]{-----------------------------------------------
  // [ ]   [尳] ŭ [VCOM:RXD]  Ѵ
  // [ ]  ʱȭ Ѵ( ϴ ).
  //}-----------------------------------------------------------------------

  //[VAR]
  //{
      class VMOS   *vmos;

  //}

  //[VMOSCOM ּҾ]{-----
  VMOS_GetPtr(&vmos);
  //}-----------------------

  //[]
  //{
      // [ ]  Ѵ.
      vmos->ComM1_Rxd(comM1_TxdBuf, comM1_TxdCount);

  //}

  //[ó]
  //{
      // ϿǷ ش.
      comM1_TxdCount = 0;

  //}

  return;

}

void __fastcall Tmain_Form::ComM1_Rxd(// .
                                      DTU1  *pBuf,
                                      // .
                                      DTU2   pCount)
{
  //[2009.04.12.][!!!]{-------------------------------------
  //  []   []  ŭ Ѵ.
  //̴  []  ȴ.
  //}-------------------------------------------------------------

  //[]
  //{
      //[ ] Ѵ.
      memmove(comM1_RxdBuf, pBuf, pCount);

  //}

  //[ó]
  //{
      //[ ]  Ű Ѵ.
      comM1_RxdCount = pCount;

  //}

  return;

}

void __fastcall Tmain_Form::ComM2_Txd(void)
{
  //[2009.04.12.][!!!]{-----------------------------------------------
  // [ ]   [尳] ŭ [VCOM:RXD]  Ѵ
  // [ ]  ʱȭ Ѵ( ϴ ).
  //}-----------------------------------------------------------------------

  //[VAR]
  //{
      class VMOS   *vmos;

  //}

  //[VMOSCOM ּҾ]{-----
  VMOS_GetPtr(&vmos);
  //}-----------------------

  //[]
  //{
      // [ ]  Ѵ.
      vmos->ComM2_Rxd(comM2_TxdBuf, comM2_TxdCount);

  //}

  //[ó]
  //{
      // ϿǷ ش.
      comM2_TxdCount = 0;

  //}

  return;

}

void __fastcall Tmain_Form::ComM2_Rxd(// .
                                      DTU1  *pBuf,
                                      // .
                                      DTU2   pCount)
{
  //[2009.04.12.][!!!]{-------------------------------------
  //  []   []  ŭ Ѵ.
  //̴  []  ȴ.
  //}-------------------------------------------------------------

  //[]
  //{
      //[ ] Ѵ.
      memmove(comM2_RxdBuf, pBuf, pCount);

  //}

  //[ó]
  //{
      //[ ]  Ű Ѵ.
      comM2_RxdCount = pCount;

  //}

  return;

}

//------------------------------------------------------------------------------
//[ѽð Ÿ̸]---------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall Tmain_Form::vmosApiTimeOut_TimerTimer(TObject *Sender)
{
  //[2010.06.13.][!!!]{--------------------------------------------------
  //<VMOS>   [API_ðXXX()]  ϱ  ̴.
  // Ÿ̸   ش API  óȴ.
  //
  //API ʿ Ʒ  Ÿ̸ <Enabled> Ӽ  аϴ.
  //<vmosApiTimeOut_Timer->Enabled : false> : ðѿ ɸ.
  //<vmosApiTimeOut_Timer->Enabled : true>  :  ðѿ Ȱɸ().
  //}--------------------------------------------------------------------------

  //[Ÿ̸ ]
  //{
      //[!]{----------------------------------------
      //ȸ̹Ƿ ⼭  Ÿ̸Ӹ ش.
      //}-------------------------------------------

      vmosApiTimeOut_Timer->Enabled = false;

  //}

}

void __fastcall Tmain_Form::timeOut_TimerTimer(TObject *Sender)
{
  //[2009.04.11.][!!!]{------------------------------------------------------
  //[ ð  Ÿ̸]   ð Ǹ Ȱȭ Ų.
  //ٸ   [Ÿ̸]  Ȱȭ ٸ [ð]  ɸ  ȴ.
  //}------------------------------------------------------------------------------

  timeOut_Timer->Interval = 0;
  timeOut_Timer->Enabled  = false;

  return;

}

void __fastcall Tmain_Form::debug_TimerTimer(TObject *Sender)
{
  //[2009.04.17.][!!!]{-----------
  // []  ⼭ Ѵ.
  //}-----------------------------------
                                                  
  //[VAR]
  //{
      class  VDEBUG  *vdebug;

  //}

  //[VDEBUG ġ ]{---
  VDEBUG_GetPtr(&vdebug);
  //}---------------------

  //[ ] ó Լ ȣ.
  vdebug->Debug();

  return;

}

void __fastcall Tmain_Form::btnQueue_TimerTimer(TObject *Sender)
{
  //[2009.04.17.][!!!]{----------------------------------------------------------
  //<ACK>  Ȯϰ ִ ߿ ٸ ư  Ǵ  <ACK>  ȮҼ
  //  ߻Ѵ.  <ACK>  Ȯ   ϴ ش ư óԼ
  //̰ ߴٰ <ACK> Ȯ  ڵ óϰ .
  // [QUEUE]   ̴.
  //̷ Ͽ  Ͽ <ACK>  ݵ  Ȯεȴ.
  //}----------------------------------------------------------------------------------

  //[Ÿ̸  ]
  //{
      //[2011.07.22.][߿!!!]{---------------------------------------------------------
      //ݵ Ÿ̸Ӹ  ¿ Ѵ.
      //׷    ٸ  ߻Ѵ.
      //̴ <ide_tree_Form->_EVENT_TabSelect()>  [ ]  [⿭ ] 
      //߻ϴ   ȭ   ʴ  ߻Ͽ.
      //   ۵Ǵ  ȮϿ.
      //}---------------------------------------------------------------------------------
      
      btnQueue_Timer->Enabled = false;

  //}

  //[<ACK> Ȯ Ÿ̸Ӱ ΰ?]
  //{
      if(timeOut_Timer->Enabled == true)
      {
        //[2011.07.22.][Ÿ̸]{------------------------
        // óؼ ȵǹǷ  óϱ Ͽ
        //ٽ  Ÿ̸Ӹ  Ų.
        btnQueue_Timer->Enabled = true;
        //}-----------------------------------------------

        return;

      }

  //}

  //[ ư ó]
  //{
      //ϵ ư ֳ?
      if(BtnQueue_Event != NULL) { BtnQueue_Event(); }

      // Ǵ   ϱ Ͽ ٽ ʱȭ Ѵ.
      BtnQueue_Event = NULL;

      // Ǵ  ϱ Ͽ ʱȭ Ѵ.
      btnQueue_Timer->Enabled = false;

  //}

  return;

}

void __fastcall Tmain_Form::autoSave_TimerTimer(TObject *Sender)
{
  //[2018.05.05.][!!!]{-------------------------------------------------
  //[˵-IDE:ڵ  ] .
  // ð ֱ   ִ   ڵ .
  //
  //[ȭ]  [:true]   Ÿ̸Ӱ ڵ Ͽ óϹǷ
  //⼭ []  Ȯ ʿ .
  //
  //[!!!]-----------------------------------------------------------------
  //, []   ʰ []  츸 ó.
  //}-------------------------------------------------------------------------

  //[ ΰ?]
  //{
      //[!]{-----------------------------------------------------
      //[]  ƴ϶ []   ó ʴ´.
      //[]   <_tabindex : 0>.
      //}--------------------------------------------------------
      
      if(ide_buttons_Form->_tabs->_tabindex > 0) return;

  //}

  IDE_File_SaveAll();
  
}

void __fastcall Tmain_Form::FormClose(TObject *Sender, TCloseAction &Action)
{
  //[2009.04.20.][!!!]{-----------------
  //   <*.opt>  Ѵ.
  //}-----------------------------------------

  IDE_OptionFile_Save();

  return;

}

void __fastcall Tmain_Form::FormShow(TObject *Sender)
{
  //[2022.07.15.][]{-------------------------------------------------------
  //  [˵-IDE] GUI  ϼ ̰,
  //GUI    Ҽ ִ ̴.
  //
  //[߿]***********************************************************************
  //, <main_Form>    ̰   ٸ [׸ǰ]  ̰ ǹǷ
  //<IDE_OnShow()>  [V] ½ Ȯ ǥ  ȵǹǷ ⼭
  //ϴ, <ideShowTimer>  <0.5>    Ű ͸ Ѵ.
  //<0.5>   ׸Ⱑ Ϸ  <IDE_OnShow()>  óѴ.
  //}----------------------------------------------------------------------------

  ideShowTimer->Interval = 500; //<0.5>

  ideShowTimer->Enabled = true;

}

void __fastcall Tmain_Form::ideShowTimerTimer(TObject *Sender)
{
  //[2022.07.15.][]

  // ̺Ʈ ߻ϴ  ϱ Ͽ Ÿ̸ .
  ideShowTimer->Enabled = false;

  //[˵-IDE]  ν ó .
  IDE_OnShow();
  
}
//------------------------------------------------------------------------------
//[׸ǰȮ]----------------------------------------------------------------
//------------------------------------------------------------------------------

void __fastcall Tmain_Form::GIGYENICS_GuiPart_Event(void)
{
  //[2010.02.13.][!!!]{--------------------------
  // [ǰ]  [Լ]  Ȯϱ  ̴.
  //}--------------------------------------------------

  //[VAR]
  //{
      char  str[512];

  //}


  //ide_msgbox_Form->_MsgBox(d_MSGBOX_info, IntToStr(_GList->_itemSelIndex).c_str());


  //_GList->_ItemSelStr(str);
  //_GList->_ItemMouseSelStr(str);
  //_GVmos->_captionTitleLabel->_Caption(str);

  //_GVmos->_captionTitleLabel->_Caption(" !!!");





}

/*
#include  "event.h"
#include  "msg_queue.h"

char tempBuf[2550];
char printBoxBuf[1024];
*/


//#include  "ide_caption.h"


void __fastcall Tmain_Form::GIGYENICS_GuiPart_Test1(void)
{
  //[2010.02.10.][!!!]{---------
  //ο  Լ ϳ Ѵ.
  //}---------------------------------


/*

  //[VAR]
  //{
      int  i;

  //}

  //_GList->_ItemAdd(" н ÷ 尣 \r\n ϴó\r\n鼺\r\n");

  //_GList->_ItemReplace(4, " н ");

  _GList->_ItemInsert(5, " н ÷ 尣 \r\n ϴó\r\n鼺\r\n");

  //_GList->_ItemDelete(0);

  return;



  GVmos_Create(tempBuf, 12, 100, 100, 600, 300, true);

  return;


  ide_editor_Form->_GDotMatrix->_RotStep(1);
  ide_editor_Form->_GDotMatrix->_RotTime(100);

  //ide_editor_Form->_GDotMatrix->_RotStr("н ÷ܴ尣 : http://www.gigyenics.co.kr");
  ide_editor_Form->_GDotMatrix->_RotStr("ide_editor_Form->_GDotMatrix->_PrintStr");

  ide_editor_Form->_GDotMatrix->_RotTimer(true);

  return;





      //ide_editor_Form->_GDotMatrix->_Border(true);
      //ide_editor_Form->_GDotMatrix->_Led_Make(d_GDotMatrix_LedBox, 7, clBlack, clWhite, false, clRed, clWhite);

      for(i = 0; i > -250; i--)
      {

        ide_editor_Form->_GDotMatrix->_PrintStr(i, 0, "н ÷ܴ尣 : http://www.gigyenics.co.kr");
        Application->ProcessMessages();

        Sleep(100);

      }

      return;


  //[GDotMatrix]
  //{


      _GDotMatrix->_Border(false);
      _GDotMatrix->_BorderColor(clBlue);
      _GDotMatrix->_LedOrgX(0);
      _GDotMatrix->_LedOrgY(0);
      _GDotMatrix->_LedGap(1);

      //0x000080FF

      //_GDotMatrix->_ledTransparent = false;

      _GDotMatrix->_Led_Make(d_GDotMatrix_LedBox, 4, clBlack, clWhite, false, clRed, clWhite);

      for(i = 0; i > -250; i--)
      {

        _GDotMatrix->_PrintStr(i, 0, "          н ÷ܴ尣 : http://www.gigyenics.co.kr");
        Application->ProcessMessages();

        Sleep(100);

      }

      return;

  //}

  //[GPrintBox]
  //{
      _GPrintBox->_PrintItem_Set(clBlue, d_FONTSTYLE_default, clWhite);

      FILE_Open_inBUF("H:\\GIGYENICS\\GIGYEIN\\G_PART\\BORLAND\\Turbo2006\\@\\˵\\@\\74HC165\\main.c",
                      (unsigned char *)tempBuf, &i);

      _GPrintBox->_Buf(printBoxBuf);
      _GPrintBox->_BufSize(1024);


      //  ׸ ٲ۴.
      _GPrintBox->_EditorBack_SetJpeg("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\147BE60C4A7CE37510A206.jpeg");
      _GPrintBox->_EditorBack_Brightness(150);

      //STR_Assign(printBoxBuf, "ѱ \r\n ̴.\r\nѱ  Ϻ ̴!!!\r\n"
      //                        "C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\164988024AFA6CC525E322.jpeg" );

      //_GPrintBox->_PrintAdd(" ");

      //[¼ ]
      //{
          _GPrintBox->_Print(tempBuf);

          _GPrintBox->_PrintItem_Set(clBlue, d_FONTSTYLE_bold, clWhite);
          _GPrintBox->_PrintAdd("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\147BE60C4A7CE37510A206.jpeg\r\n"
                                "н\r\n÷\r\n尣");

          _GPrintBox->_PrintItem_Set(clWhite, d_FONTSTYLE_default, clRed);
          _GPrintBox->_PrintAdd("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\147BE60C4A7CE37510A206.jpeg\r\n"
                                "н\r\n÷\r\n尣");

          _GPrintBox->_PrintItem_Set(clGreen, d_FONTSTYLE_bold, clWhite);
          _GPrintBox->_PrintAdd("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\147BE60C4A7CE37510A206.jpeg\r\n"
                                "н\r\n÷\r\n尣");

          _GPrintBox->_PrintItem_Set(clGray, d_FONTSTYLE_default, clYellow);
          _GPrintBox->_PrintAdd("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\147BE60C4A7CE37510A206.jpeg\r\n"
                                "н\r\n÷\r\n尣");

      //}

      _GPrintBox->_BorderColor(clRed);

      _GPrintBox->_ScrollVColor(clBlue);
      _GPrintBox->_ScrollHColor(clBlack);

      return;

  //}



  //[GEditor]
  //{
      //  ׸ ٲ۴.
      _GEditor->_EditorBack_SetJpeg("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\164988024AFA6CC525E322.jpeg");

      _GEditor->_EditorBack_Brightness(150);

      return;

  //}


  //_GEditor->_editorEdit->_EDITFILE_NewFile();

  //_GEditor->_editorEdit->_EditBackBrightness(150);

  for(i = 0; i < 2; i++)
  {
    _GEditor->_FocusLine(100); Application->ProcessMessages();
    _GEditor->_FocusLine(50);  Application->ProcessMessages();
    _GEditor->_FocusLine(150); Application->ProcessMessages();
    _GEditor->_FocusLine(10);  Application->ProcessMessages();
    _GEditor->_FocusLine(2);   Application->ProcessMessages();
    _GEditor->_FocusLine(80);  Application->ProcessMessages();
    _GEditor->_FocusLine(30);  Application->ProcessMessages();
    _GEditor->_FocusLine(150); Application->ProcessMessages();
    _GEditor->_FocusLine(100); Application->ProcessMessages();

  }
*/

  


}

void __fastcall Tmain_Form::GIGYENICS_GuiPart_Test0(void)
{
  //[2010.01.25.][!!!]{-----------------------------
  // ߵǴ [׸ǰ]  Ȯ  ̴.
  //}-----------------------------------------------------






  

/*
  //[VAR]
  //{
      struct FONTRESOURCE  *fontresource;

  //}

  //[ڵ]
  //{
      FONTRESOURCE_GetHandle(&fontresource);

  //}

  //[⺻ȯ ]
  //{
      //[2010.02.04.][߰!!!]{----------------------------
      //  ⺻ ǹǷ   ־ Ѵ.
      //}----------------------------------------------------

      GPART_GVmos_Create();

  //}

  //[ǰ ]
  //{
      GPART_GBalloonBox_Create();

      GPART_GHint_Create();

      GPART_GMsgBox_Create();

      GPART_GFindDialog_Create();


  //}
*/
  //[GVmos]
  //{
      /*
      GPART_GVmos_GetPtr(&_GVmos);

      _GVmos->Visible = true;
      _GVmos->_baseForm->SetFocus();

      //_GVmos->_BackColor(clGray);

      //_GVmos->_CaptionBackColor(clYellow);
      //_GVmos->_CaptionFontColor(clLime);
      //_GVmos->_CaptionFontStyle(d_FONTSTYLE_bold);
      //_GVmos->_BackColor(clYellow);
      */

  //}

  //[GForm]
  //{
      /*
      _GForm          = new TGForm_Form(_GVmos);
      //_GForm->Parent  = _GVmos->_baseForm;

      _GForm->Width  = 550;
      _GForm->Height = 350;

      //ȭ ߰ ġϰ .
      _GForm->Left = (_GVmos->Width/2 - _GForm->Width/2);
      _GForm->Top  = (_GVmos->Height/2 - _GForm->Height/2);

      _GForm->Visible = true;


      //_GForm->_BorderColor(clBlue);
      //_GForm->_OutLineColor(clRed);
      //_GForm->_BackColor(clBlack);
      //_GForm->_CaptionFontColor(clLime);
      //_GForm->_CaptionFontStyle(d_FONTSTYLE_bold);
     */

  //}

  //[GList]
  //{
      /*
      _GList          = new TGList_Form(Application);
      _GList->Parent  = _GVmos->_baseForm;
      _GList->Visible = true;

      _GList->_Left(10);
      _GList->_Top(10);
      _GList->_Width(200);
      _GList->_Height(95);

      //_GList->_FontColor(clBlack);
      //_GList->_BackColor(clSilver);

      //_GList->_BorderColor(clRed);

      _GList->_AutoWidth(true);
      _GList->_AutoHeight(true);

      //_GList->_FontSelColor(clYellow);
      //_GList->_FontSelBackColor(clBlue);

      //_GList->_FontMouseSelColor(clYellow);
      //_GList->_FontMouseSelBackColor(clRed);

      //_GList->_MenuMode(true);
      //_GList->_ScrollVisible(true);

      _GList->_ItemStr("  \r\n"
                       " ߶󳻱 \r\n"
                       " ̱ \r\n"
                       "\r\n"
                       "  \r\n"
                       " μ ");

      //[Լ]
      //{
          //_GList->_EVENT_ItemSelect = GIGYENICS_GuiPart_Event;
          //_GList->_EVENT_ItemMouseSelect = GIGYENICS_GuiPart_Event;
          //_GList->_EVENT_FocusKill  = GIGYENICS_GuiPart_Event;
          //_GList->_EVENT_FocusSet   = GIGYENICS_GuiPart_Event;
          //_GList->_EVENT_MouseEnter = GIGYENICS_GuiPart_Event;
          //_GList->_EVENT_MouseLeave = GIGYENICS_GuiPart_Event;

      //}

      //_GList->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      //_GList->_BalloonHelpUse(true);
      */

  //}


  //[GPrintBox]
  //{
      /*
      _GPrintBox          = new TGPrintBox_Form(Application);
      _GPrintBox->Parent  = _GForm->_baseForm;
      _GPrintBox->Visible = true;

      _GPrintBox->Top  = 5;
      _GPrintBox->Left = 5;

      //  ׸ ٲ۴.
      _GPrintBox->_EditorBack_SetJpeg("C:\\Documents and Settings\\Administrator\\My Documents\\My Pictures\\147BE60C4A7CE37510A206.jpeg");
      _GPrintBox->_EditorBack_Brightness(150);
      */

  //}


  //[GDotMatrix]
  //{
      /*
      _GDotMatrix          = new TGDotMatrix_Form(Application);
      _GDotMatrix->Parent  = _GPrintBox;
      _GDotMatrix->Visible = true;

      _GDotMatrix->Left = 10;
      _GDotMatrix->Top  = 70;


      _GPrintBox->_scrollH->BringToFront();
      _GPrintBox->_scrollV->BringToFront();


      //_GDotMatrix->_BackColor(clBlack);

      _GDotMatrix->_BackBmp(_GPrintBox->_bmp_back_, 10, 70);


      FONTPACK_SetFont_withName(&(_GDotMatrix->_font), 3, "ü(6_12__d_v).gft");
      _GDotMatrix->_font.en_offset_left  = 1;
      _GDotMatrix->_font.en_offset_right = 0;

      _GDotMatrix->_ledGap = 1;


      //_GDotMatrix->_Led_Make(d_GDotMatrix_LedBox, 4, clBlack, clWhite, false, clWhite, clWhite);
      _GDotMatrix->_Led_Make(d_GDotMatrix_LedBox, 4, 0x000080FF, clBlack, false, clBlack, clBlack);
      */

  //}


  //[GEditor]
  //{
      /*
      _GEditor          = new TGEditor_Form(Application);
      _GEditor->Parent  = _GForm->_baseForm;
      _GEditor->Visible = true;

      _GEditor->Top  = 10;
      _GEditor->Left = 10;

      _GEditor->_BorderColor(clBlue);

      //.
      _GEditor->_editorEdit->_EDITFILE_NewFile();

      _GEditor->_ScrollVColor(clGreen);
      _GEditor->_ScrollHColor(clRed);

      _GEditor->_LineArrowColor(clRed);
      _GEditor->_BreakPointColor(clRed);

      //_GEditor->_FocusLineNum(43);
      //_GEditor->_FocusLineFontColor(clYellow);
      _GEditor->_FocusLineBackColor(clLime);

      //[Ư Ӽ]
      //{
          //_GEditor->_Syntax_ColorKeyword(clRed);
          //_GEditor->_Syntax_ColorString(clBlue);
          //_GEditor->_Syntax_ColorDirective(clYellow);
          //_GEditor->_Syntax_ColorComment(clLime);

          _GEditor->_Document_FileKind(d_Editor_FileKind_c);

      //}
      */

  //}


  //[GEdit]
  //{
      /*
      _GEdit          = new TGEdit_Form(Application);
      _GEdit->Parent  = _GForm->_baseForm;
      _GEdit->Visible = true;

      //ȭ ߰ ġϰ .,
      _GEdit->_Left(10);
      _GEdit->_Top(10);
      _GEdit->_Width(200);
      //_GEdit->_Height(20);

      _GEdit->_BorderColor(clRed);
      _GEdit->_FontColor(clBlue);
      _GEdit->_FontStyle(d_FONTSTYLE_bold);
      _GEdit->_BackColor(clYellow);

      //[Լ]
      //{
          _GEdit->_EVENT_KeyEnter = GIGYENICS_GuiPart_Event;

      //}
      */

  //}



  //[GLabel]
  //{
      /*
      _GLabel          = new TGLabel_Form(Application);
      _GLabel->Parent  = _GVmos->_baseForm;
      _GLabel->Visible = true;

      _GLabel->_Left(10);
      _GLabel->_Top(10);
      _GLabel->_Width(400);
      _GLabel->_Height(16);

      FONTPACK_SetFont_withName(&(_GLabel->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      _GLabel->_GBalloonBox->_font.en_offset_left  = 1;
      _GLabel->_GBalloonBox->_font.en_offset_right = 0;

      //FONTPACK_SetFont_withName(&(_GLabel->_font), 0, "ü(16_16_ѱ_d_f).gft");
      //FONTPACK_SetFont_withName(&(_GLabel->_font), 3, "ü(8_16__b_v).gft");
      //_GLabel->_font.en_offset_left  = 2;
      //_GLabel->_font.en_offset_right = 0;

      _GLabel->_FontColor(clBlack);
      _GLabel->_BackColor(clYellow);

      _GLabel->_Border(true);
      _GLabel->_BorderColor(clRed);


      _GLabel->_AutoWidth(true);
      _GLabel->_AutoHeight(true);


      _GLabel->_Caption(" ˸ gigyenics GIGYENICS \r\n н ÷ 尣 \r\n KOREA http://www.gigyenics.co.kr \r\n ˸ gigyenics GIGYENICS ");
      //_GLabel->_Caption("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GLabel->_CaptionAutoPosV(false);
      //_GLabel->_CaptionAutoPosH(true);


      _GLabel->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GLabel->_BalloonHelpUse(true);
      */

  //}



  //[GMsgBox]
  //{
      /*
      _GMsgBox          = new TGMsgBox_Form(Application);
      _GMsgBox->Parent  = _GVmos->_baseForm;
      //_GMsgBox->Visible = true;

      //_GMsgBox->_PartColor(clRed);
      //_GMsgBox->_BorderColor(clRed);
      //_GMsgBox->_OutLineColor(clRed);
      //_GMsgBox->_BackColor(clYellow);
      //_GMsgBox->_BtnBackColor(clSilver);
      //_GMsgBox->_BtnFontColor(clRed);
      //_GMsgBox->_BtnFontStyle(d_FONTSTYLE_bold);
      //_GMsgBox->_MsgFontColor(clGreen);
      //_GMsgBox->_MsgFontStyle(d_FONTSTYLE_bold);
      //_GMsgBox->_CaptionFontColor(clLime);
      //_GMsgBox->_CaptionFontStyle(d_FONTSTYLE_bold);

      //_GMsgBox->_MsgBox(d_MSGBOX_default, "Ȯο빮ڿ");

      //_GMsgBox->_MsgBox(d_MSGBOX_default,
      //                  "˸ GIGYENICS\r\nн ÷ 尣\r\nhttp://www.gigyenics.co.kr");

      //_GMsgBox->_MsgBox_OkCancel(d_MSGBOX_default,
      //                           "˸ GIGYENICS\r\nн ÷ 尣\r\nhttp://www.gigyenics.co.kr");

      _GMsgBox->_MsgBox_Edit(d_MSGBOX_info,
                             "˸ GIGYENICS\r\nн ÷ 尣\r\nhttp://www.gigyenics.co.kr");
      */

  //}



  //[GScrollH]
  //{
      /*
      _GScrollH          = new TGScrollH_Form(Application);
      _GScrollH->Parent  = _GVmos->_baseForm;
      _GScrollH->Visible = true;

      _GScrollH->_Left(10);
      _GScrollH->_Top(10);
      _GScrollH->_Width(600);
      _GScrollH->_Height(15);

      _GScrollH->_DesignSize(100);
      _GScrollH->_Min(0);
      _GScrollH->_Max(200);

      _GScrollH->_Position(100);

      FONTPACK_SetFont_withName(&(_GScrollH->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      _GScrollH->_GBalloonBox->_font.en_offset_left  = 1;
      _GScrollH->_GBalloonBox->_font.en_offset_right = 0;

      _GScrollH->_Border(true);
      _GScrollH->_BorderColor(clRed);

      _GScrollH->_BackColor(clYellow);
      _GScrollH->_ThumbColor(clRed);
      _GScrollH->_ThumbBackColor(clBlack);
      _GScrollH->_ArrowLColor(clBlue);
      _GScrollH->_ArrowRColor(clGreen);




      _GScrollH->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GScrollH->_BalloonHelpUse(true);
      */

  //}



  //[GEdgeBox]
  //{
      /*
      _GEdgeBox          = new TGEdgeBox_Form(Application);
      _GEdgeBox->Parent  = _GVmos->_baseForm;
      _GEdgeBox->Visible = true;

      //ȭ ߰ ġϰ .,
      _GEdgeBox->_Left(10);
      _GEdgeBox->_Top(10);

      _GEdgeBox->_Width(100);
      _GEdgeBox->_Height(20);

      _GEdgeBox->_BackColor(clYellow);
      _GEdgeBox->_BorderColor(clRed);

      */


  //}

  //[GEdit]
  //{
      /*
      _GEdit          = new TGEdit_Form(Application);
      _GEdit->Parent  = _GVmos->_baseForm;
      _GEdit->Visible = true;

      //ȭ ߰ ġϰ .,
      _GEdit->_Left(10);
      _GEdit->_Top(10);
      _GEdit->_Width(200);
      //_GEdit->_Height(20);

      //_GEdit->_BorderColor(clRed);
      //_GEdit->_FontColor(clBlue);
      //_GEdit->_FontStyle(d_FONTSTYLE_bold);
      //_GEdit->_BackColor(clYellow);
      */

  //}


  //[GCaret]
  //{
      /*
      _GCaret          = new TGCaret_Form(Application);
      _GCaret->Parent  = _GVmos->_baseForm;

      //ȭ ߰ ġϰ .,
      _GCaret->Left = 10;
      _GCaret->Top  = 10;

      _GCaret->_Show();

      _GCaret->_FontColor(clYellow);
      _GCaret->_BackColor(clBlue);
      _GCaret->_Shape_Composition('');
      */

  //}


  //[GFindDialog]
  //{
      /*
      _GFindDialog          = new TGFindDialog_Form(Application);
      _GFindDialog->Parent  = _GVmos->_baseForm;

      //ȭ ߰ ġϰ .,
      _GFindDialog->Left = (_GVmos->Width/2 - _GFindDialog->Width/2);
      _GFindDialog->Top  = (_GVmos->Height/2 - _GFindDialog->Height/2);

      _GFindDialog->Visible = true;

      //_GFindDialog->_BtnBackColor(clYellow);
      //_GFindDialog->_BackColor(clYellow);
      //_GFindDialog->_BorderColor(clLime);
      //_GFindDialog->_PartColor(clRed);

      //[]  Ѵ.
      //_GFindDialog->_GEditor = (TGEditor_Form *)editor_edit_Form;
      */

  //}



  //[GForm]
  //{
      /*
      _GForm          = new TGForm_Form(Application);
      _GForm->Parent  = _GVmos->_baseForm;

      //ȭ ߰ ġϰ .,
      //_GForm->Left = (Screen->Width/2 - _GForm->Width/2);
      //_GForm->Top  = (Screen->Height/2 - _GForm->Height/2);

      _GForm->Left = (_GVmos->Width/2 - _GForm->Width/2);
      _GForm->Top  = (_GVmos->Height/2 - _GForm->Height/2);

      _GForm->Visible = true;

      //_GForm->_BorderColor(clBlue);
      //_GForm->_OutLineColor(clRed);
      //_GForm->_BackColor(clWhite);
      //_GForm->_CaptionFontColor(clLime);
      //_GForm->_CaptionFontStyle(d_FONTSTYLE_bold);
      */

  //}


  //[GLabel]
  //{
      /*
      _GLabel          = new TGLabel_Form(Application);
      _GLabel->Parent  = _GVmos->_baseForm;
      _GLabel->Visible = true;

      _GLabel->_Left(10);
      _GLabel->_Top(10);
      _GLabel->_Width(400);
      _GLabel->_Height(16);

      FONTPACK_SetFont_withName(&(_GLabel->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      _GLabel->_GBalloonBox->_font.en_offset_left  = 1;
      _GLabel->_GBalloonBox->_font.en_offset_right = 0;

      //FONTPACK_SetFont_withName(&(_GLabel->_font), 0, "ü(16_16_ѱ_d_f).gft");
      //FONTPACK_SetFont_withName(&(_GLabel->_font), 3, "ü(8_16__b_v).gft");
      //_GLabel->_font.en_offset_left  = 2;
      //_GLabel->_font.en_offset_right = 0;

      _GLabel->_FontColor(clBlack);
      _GLabel->_BackColor(clYellow);

      _GLabel->_Border(true);
      _GLabel->_BorderColor(clRed);


      _GLabel->_AutoWidth(true);
      _GLabel->_AutoHeight(true);


      _GLabel->_Caption(" ˸ GIGYENICS \r\n н ÷ 尣 \r\n http://www.gigyenics.co.kr ");
      //_GLabel->_Caption("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GLabel->_CaptionAutoPosV(false);
      //_GLabel->_CaptionAutoPosH(true);


      _GLabel->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GLabel->_BalloonHelpUse(true);
      */

  //}


  //[GRadioButton]
  //{
      /*
      _GRadioButton          = new TGRadioButton_Form(Application);
      _GRadioButton->Parent  = _GVmos->_baseForm;
      _GRadioButton->Visible = true;

      _GRadioButton->_Left(10);
      _GRadioButton->_Top(10);

      //_GRadioButton->_FrontColor(clBlue);
      //_GRadioButton->_BackColor(clLime);
      _GRadioButton->_Checked(true);

      _GRadioButton->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GRadioButton->_BalloonHelpUse(true);

      FONTPACK_SetFont_withName(&(_GRadioButton->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      FONTPACK_SetFont_withName(&(_GRadioButton->_GBalloonBox->_font), 7, "ü(6_12__b_v).gft");

      _GRadioButton->_GBalloonBox->_font.en_offset_left  = 1;
      _GRadioButton->_GBalloonBox->_font.en_offset_right = 0;
      //_GRadioButton->_GBalloonBox->_FontStyle(d_FONTSTYLE_bold);
      _GRadioButton->_GBalloonBox->_FontColor(clBlue);
      _GRadioButton->_GBalloonBox->_BackColor(clYellow);

      _GRadioButton->_Enable(true);
      */

  //}




  //[GCheckButton]
  //{
      /*
      _GCheckButton          = new TGCheckButton_Form(Application);
      _GCheckButton->Parent  = _GVmos->_baseForm;
      _GCheckButton->Visible = true;

      _GCheckButton->_Left(10);
      _GCheckButton->_Top(10);


      //_GCheckButton->_FrontColor(clRed);
      //_GCheckButton->_BackColor(clYellow);
      _GCheckButton->_Checked(true);


      _GCheckButton->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GCheckButton->_BalloonHelpUse(true);

      FONTPACK_SetFont_withName(&(_GCheckButton->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      FONTPACK_SetFont_withName(&(_GCheckButton->_GBalloonBox->_font), 7, "ü(6_12__b_v).gft");

      _GCheckButton->_GBalloonBox->_font.en_offset_left  = 1;
      _GCheckButton->_GBalloonBox->_font.en_offset_right = 0;
      _GCheckButton->_GBalloonBox->_FontStyle(d_FONTSTYLE_bold);
      _GCheckButton->_GBalloonBox->_FontColor(clBlue);
      _GCheckButton->_GBalloonBox->_BackColor(clYellow);

      //_GCheckButton->_Enable(false);
      */

  //}



  //[GScrollV]
  //{
      /*
      _GScrollV          = new TGScrollV_Form(Application);
      _GScrollV->Parent  = _GVmos->_baseForm;
      _GScrollV->Visible = true;

      _GScrollV->_Left(10);
      _GScrollV->_Top(10);
      _GScrollV->_Width(15);
      _GScrollV->_Height(150);

      FONTPACK_SetFont_withName(&(_GScrollV->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      _GScrollV->_GBalloonBox->_font.en_offset_left  = 1;
      _GScrollV->_GBalloonBox->_font.en_offset_right = 0;

      _GScrollV->_Border(true);
      _GScrollV->_BorderColor(clRed);

      _GScrollV->_BackColor(clYellow);
      _GScrollV->_ThumbColor(clRed);
      _GScrollV->_ThumbBackColor(clBlack);
      _GScrollV->_ArrowUColor(clBlue);
      _GScrollV->_ArrowDColor(clGreen);

      _GScrollV->_DesignSize(100);
      _GScrollV->_Min(0);
      _GScrollV->_Max(200);

      _GScrollV->_Position(100);


      _GScrollV->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GScrollV->_BalloonHelpUse(true);
      */

  //}


  //[GProgress]
  //{
      /*
      _GProgress          = new TGProgress_Form(Application);
      _GProgress->Parent  = _GVmos->_baseForm;
      _GProgress->Visible = true;

      _GProgress->_Left(10);
      _GProgress->_Top(10);
      _GProgress->_Width(600);
      _GProgress->_Height(20);

      FONTPACK_SetFont_withName(&(_GProgress->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      _GProgress->_GBalloonBox->_font.en_offset_left  = 1;
      _GProgress->_GBalloonBox->_font.en_offset_right = 0;

      _GProgress->_BackColor(clYellow);

      _GProgress->_BorderColor(clRed);
      _GProgress->_BorderGap(4);

      _GProgress->_ProgressBackColor(clLime);
      _GProgress->_ProgressBorderColor(clBlack);
      _GProgress->_ProgressColor(clGreen);

      _GProgress->_Min(0);
      _GProgress->_Max(100);
      _GProgress->_Progress(50);

      _GProgress->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GProgress->_BalloonHelpUse(true);
      */

  //}

  //[GTabs]
  //{
      /*
      _GTabs          = new TGTabs_Form(Application);
      _GTabs->Parent  = _GVmos->_baseForm;
      _GTabs->Visible = true;

      _GTabs->_Left(10);
      _GTabs->_Top(10);
      _GTabs->_Width(600);
      _GTabs->_Height(16);

      //FONTPACK_SetFont_withName(&(_GTabs->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      //_GTabs->_GBalloonBox->_font.en_offset_left  = 1;
      //_GTabs->_GBalloonBox->_font.en_offset_right = 0;

      //FONTPACK_SetFont_withName(&(_GTabs->_font), 0, "ü(16_16_ѱ_d_f).gft");
      //FONTPACK_SetFont_withName(&(_GTabs->_font), 3, "ü(8_16__b_v).gft");
      //_GTabs->_font.en_offset_left  = 2;
      //_GTabs->_font.en_offset_right = 0;

      _GTabs->_FontSelColor(clBlack);
      _GTabs->_FontSelStyle(d_FONTSTYLE_bold);

      _GTabs->_FontDSelColor(clBlue);
      _GTabs->_FontDSelStyle(d_FONTSTYLE_default);

      _GTabs->_Tabs(" ѹα \r\n н \r\n ÷ܴ尣 ");
      _GTabs->_TabSelColor(clYellow);

      _GTabs->_BackColor(clWhite);

      _GTabs->_BorderColor(clRed);
      //_GTabs->_BorderSelUse(false);

      //_GTabs->_Width_Self();

      _GTabs->_BlankText("н(Gigyenics) ÷ 尣");
      _GTabs->_BlankTextFontColor(clGreen);
      _GTabs->_BlankTextFontStyle(d_FONTSTYLE_default);

      _GTabs->_TabSelect(2);

      _GTabs->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GTabs->_BalloonHelpUse(true);
      */

  //}




  //[GBmpButton]
  //{
      /*
      _GBmpButton          = new TGBmpButton_Form(Application);
      _GBmpButton->Parent  = _GVmos->_baseForm;
      _GBmpButton->Visible = true;

      _GBmpButton->_Left(10);
      _GBmpButton->_Top(10);
      _GBmpButton->_Width(40);
      _GBmpButton->_Height(32);

      _GBmpButton->_Bitmap(ExtractFilePath(Application->ExeName) + "sysbmp\\button\\control\\compile.bmp");

      _GBmpButton->_ImageWidth(40);
      _GBmpButton->_ImageHeight(32);
      //_GBmpButton->_ImageX(10);
      //_GBmpButton->_ImageY(10);


      _GBmpButton->_IndexBitmap(true);
      _GBmpButton->_IndexWidth(40);
      _GBmpButton->_Index(0);

      _GBmpButton->_FrontColor(clBlue);
      _GBmpButton->_BackColor(clYellow);

      _GBmpButton->_Border(true);
      _GBmpButton->_BorderColor(clRed);

      _GBmpButton->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GBmpButton->_BalloonHelpUse(true);

      FONTPACK_SetFont_withName(&(_GBmpButton->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      FONTPACK_SetFont_withName(&(_GBmpButton->_GBalloonBox->_font), 7, "ü(6_12__b_v).gft");
      _GBmpButton->_GBalloonBox->_font.en_offset_left  = 1;
      _GBmpButton->_GBalloonBox->_font.en_offset_right = 0;
      _GBmpButton->_GBalloonBox->_FontStyle(d_FONTSTYLE_bold);
      */

  //}



  //[GHint]
  //{
      /*
      _GHint          = new TGHint_Form(Application);
      _GHint->Parent  = _GVmos->_baseForm;
      _GHint->Visible = false;

      //FONTPACK_SetFont_withName(&(_GHint->_font), 0, "ü(16_16_ѱ_d_f).gft");
      FONTPACK_SetFont_withName(&(_GHint->_font), 3, "ü(6_12__d_v).gft");

      _GHint->_font.en_offset_left  = 1;
      _GHint->_font.en_offset_right = 0;

      _GHint->_ShowHint(30, 10, "н(Gigyenics) : http://www.gigyenics.co.kr ѹα");

      _GHint->_BackColor(clYellow);
      _GHint->_FontColor(clBlack);
      _GHint->_BorderColor(clRed);
      */

  //}



  //[GBalloonBox]
  //{
      //̰  Ѱ ϹǷ   ʿ .

      /*
      _GBalloonBox          = new TGBalloonBox_Form(Application);
      _GBalloonBox->Parent  = _GVmos->_baseForm;
      _GBalloonBox->Visible = false;

      _GBalloonBox->Left    = 10;
      _GBalloonBox->Top     = 10;


      FONTPACK_SetFont_withName(&(_GBalloonBox->_font), 0, "ü(16_16_ѱ_d_f).gft");
      FONTPACK_SetFont_withName(&(_GBalloonBox->_font), 3, "ü(8_16__b_v).gft");

      _GBalloonBox->_font.offset_left   = 0;
      _GBalloonBox->_font.offset_right  = 0;
      _GBalloonBox->_font.offset_top    = 0;
      _GBalloonBox->_font.offset_bottom = 0;

      _GBalloonBox->_font.en_offset_left  = 2;
      _GBalloonBox->_font.en_offset_right = 0;


      _GBalloonBox->_BalloonBox(30, 10, false, "н(Gigyenics) : http://www.gigyenics.co.kr");


      _GBalloonBox->_OutLineColor(clRed);
      _GBalloonBox->_BackColor(clYellow);
      _GBalloonBox->_FontColor(clBlack);

      //_GBalloonBox->_AlphaBlend(true);
      //_GBalloonBox->_AlphaBlendValue(200);
      */


  //}


  //[GButton]
  //{
      /*
      _GButton          = new TGButton_Form(Application);
      _GButton->Parent  = _GVmos->_baseForm;
      _GButton->Visible = true;

      _GButton->_Left(10);
      _GButton->_Top(10);
      _GButton->_Width(420);
      _GButton->_Height(30);

      FONTPACK_SetFont_withName(&(_GButton->_GBalloonBox->_font), 3, "ü(6_12__d_v).gft");
      _GButton->_GBalloonBox->_font.en_offset_left  = 1;
      _GButton->_GBalloonBox->_font.en_offset_right = 0;

      FONTPACK_SetFont_withName(&(_GButton->_font), 0, "ü(16_16_ѱ_d_f).gft");
      FONTPACK_SetFont_withName(&(_GButton->_font), 3, "ü(8_16__b_v).gft");
      _GButton->_font.en_offset_left  = 2;
      _GButton->_font.en_offset_right = 0;

      _GButton->_FontColor(clBlack);
      _GButton->_BackColor(clYellow);
      _GButton->_BorderColor(clRed);

      _GButton->_Caption("н(Gigyenics) : http://www.gigyenics.co.kr");
      //_GButton->_CaptionAutoPos(false);

      _GButton->_BalloonHelpStr("н(Gigyenics) : http://www.gigyenics.co.kr");
      _GButton->_BalloonHelpUse(true);
      */

  //}


 /*

  //[Ϲ ͸   ]{-------------------------------------
  //  [(8Byte)]  [ѱC] ȿ Ѵ.
  //VMOS   ʿ䰡  []    ϹǷ
  // ſ .
  //}---------------------------------------------------------------------

  //[ide_mbutton]
  //{
      ((TGButton_Form *)_GPart_)          = new TGButton_Form(Application);
      ((TGButton_Form *)_GPart_)->Parent  = msg_msg_Form;
      ((TGButton_Form *)_GPart_)->Visible = true;

      ((TGButton_Form *)_GPart_)->Left = 10;
      ((TGButton_Form *)_GPart_)->Top  = 50;

  //}

  FONTPACK_SetFont_withName(&(((TGButton_Form *)_GPart_)->_font), 0, "ü(12_12_ѱ_d_f).gft");
  FONTPACK_SetFont_withName(&(((TGButton_Form *)_GPart_)->_font), 3, "ü(6_12__d_v).gft");

  ((TGButton_Form *)_GPart_)->_font.offset_left   = 0;
  ((TGButton_Form *)_GPart_)->_font.offset_right  = 0;
  ((TGButton_Form *)_GPart_)->_font.offset_top    = 0;
  ((TGButton_Form *)_GPart_)->_font.offset_bottom = 0;

  ((TGButton_Form *)_GPart_)->_font.en_offset_left  = 1;
  ((TGButton_Form *)_GPart_)->_font.en_offset_right = 0;

  ((TGButton_Form *)_GPart_)->_Width(300);
  ((TGButton_Form *)_GPart_)->_Height(20);

  //((TGButton_Form *)_GPart_)->_FontColor(clGreen);

  ((TGButton_Form *)_GPart_)->_Caption("н(Gigyenics) : http://www.gigyenics.co.kr");

  */

}

/*
class GTimer_CopyEx
{
  private:
  public:

  __fastcall GTimer_CopyEx(void);
  __fastcall ~GTimer_CopyEx(void);

  TTimer * timer;

  void __fastcall _TimerEvent(TObject *Sender);

};

__fastcall GTimer_CopyEx::GTimer_CopyEx(void)
{
  timer = new TTimer(NULL);
  timer->OnTimer = _TimerEvent;
  timer->Interval = 10;
  timer->Enabled = true;

}

__fastcall GTimer_CopyEx::~GTimer_CopyEx(void)
{
  ShowMessage("!!!");

  delete  timer;

}

void __fastcall GTimer_CopyEx::_TimerEvent(TObject *Sender)
{
  //  Ÿ̸  ó. 
  timer->Enabled = false;


  //   .
  // ...


  ShowMessage(" Ÿ̸ !!!");

  delete this;

}
*/

void __fastcall Tmain_Form::GIGYENICS_GUI_Test_Init(void)
{
  //[2021.03.29.][]{-------------------
  //<GIGYENICS_GUI_Test()>  ʱȭ .
  //<Tmain_Form()>  ȣ.
  //}----------------------------------------
/*
  _GImageBox = NULL;
*/
}

void __fastcall Tmain_Form::GImgBox_EVENT_Click(void)
{
/*
  //[VAR]
  //{
      AnsiString  imagePathNameExt;

      char        name[1024];

      int         bmpWidth, bmpHeight;

  //}

  //[̸ ]
  //{
      STR_GetFileNameOnly_ExceptExt(_GImageBox->_imagePathNameExt.c_str(), name);

  //}

  if     (STR_Match_NoCase(name, "G.MTDL.A") == true)
  {
    imagePathNameExt = ExtractFilePath(Application->ExeName) + "gigyenics\\etc\\gmtdl-x-pin-table\\G.MTDL.A1.jpg";

  }
  else if(STR_Match_NoCase(name, "G.MTDL.A1") == true)
  {
    imagePathNameExt = ExtractFilePath(Application->ExeName) + "gigyenics\\etc\\gmtdl-x-pin-table\\G.MTDL.B.jpg";

  }
  else if(STR_Match_NoCase(name, "G.MTDL.B") == true)
  {
    imagePathNameExt = ExtractFilePath(Application->ExeName) + "gigyenics\\etc\\gmtdl-x-pin-table\\G.MTDL.A.jpg";

  }

  Jpg_Get_Size(imagePathNameExt.c_str(), &bmpWidth, &bmpHeight);

  _GImageBox->_Width(bmpWidth + 20);
  _GImageBox->_Height(bmpHeight + 20);
  _GImageBox->Left = (Screen->Width/2 - _GImageBox->Width/2);
  _GImageBox->Top  = (Screen->Height/2 - _GImageBox->Height/2);

  _GImageBox->_ImageWidth(bmpWidth);
  _GImageBox->_ImageHeight(bmpHeight);

  _GImageBox->_Image(imagePathNameExt.c_str(), true, true);
*/
}

void __fastcall Tmain_Form::GImgBox_EVENT_Down(void)
{
//  _GImageBox->_BackColor(clRed);

}

void __fastcall Tmain_Form::GImgBox_EVENT_Up(void)
{
//  _GImageBox->_BackColor(clLime);

}

void __fastcall Tmain_Form::GImgBox_EVENT_MouseEnter(void)
{
//  _GImageBox->_BorderColor(clBlack);

}

void __fastcall Tmain_Form::GImgBox_EVENT_MouseLeave(void)
{
//  _GImageBox->_BorderColor(clRed);

}

void __fastcall Tmain_Form::GIGYENICS_GUI_Test(void)
{
  //[2018.06.11.][!!!]{----------------
  //[̳] [׸ǰ] Ȯ Ѱ.
  //}----------------------------------------


  //[Ȯο]
//{
//    int  ó;

//_Dir_λ_("C:\\Users\\AMD\\Downloads\\BB\\BB\\@MIG-41X\\");

/*
_File__̵_("C:\\Users\\AMD\\Downloads\\AA\\AA\\@MIG-41\\",
               "C:\\Users\\AMD\\Downloads\\BB\\BB\\@MIG-41X\\",
               //  <true>.
               true,
               //ȭڸ ̴  <true>.
               true,
               // ó ߴܽų  <true>.
               //   <NULL>.
               NULL,
               //[ó] ȯ.
               &ó);
*/

//MoveFile("C:\\Users\\AMD\\Downloads\\AA\\AA\\@MIG-41",
//         "C:\\Users\\AMD\\Downloads\\BB\\BB\\@MIG-41X");


return;

//}


  /*
  #if d_BuildTool_TC2006
  //{
      ShowMessage("Turbo C++ 2006  !!!");

  //}
  #else
  //{
      ShowMessage("<ECB/CE>  !!!");

  //}
  #endif
  */

  //[VAR]
  //{
      //AnsiString  fileName;

  //}

  //fileName = "C:\\Users\\AMD\\Downloads\\н\\download (6).jpeg";

  //SHBrowseForFolder("");

  //main_Form->vmos_OpenDialog->FileName = fileName;

  //main_Form->vmos_OpenDialog->Execute();


  /*
  //[2022.09.10.][߰]
  ITEMIDLIST* pItem = ILCreateFromPath("Z:\\@SX\\((@))䷻Ʈ\\2950637897_7cj4gGHZ_image.jpg");

  SHOpenFolderAndSelectItems(pItem, 0, NULL, 0);

  ILFree(pItem);
  */


//  MoveFile("C:\\Users\\AMD\\Downloads\\̸X\\", "C:\\Users\\AMD\\Downloads\\̸@\\");






/*
  //[GImageBox]
  //{
      //[2021.03.29.][߰]

      //[VAR]
      //{
          AnsiString  imagePathNameExt;

          int         bmpWidth, bmpHeight;

      //}

      if(_GImageBox != NULL) { delete _GImageBox; _GImageBox = NULL; }

      _GImageBox          = new TGImageBox_Form(this);
      _GImageBox->Parent  = NULL;

      //[ʱȭ]
      //{
          //׸ Ҵϱ.
          imagePathNameExt = ExtractFilePath(Application->ExeName) + "gigyenics\\etc\\gmtdl-x-pin-table\\G.MTDL.A.jpg";

          Jpg_Get_Size(imagePathNameExt.c_str(), &bmpWidth, &bmpHeight);

          _GImageBox->_Width(bmpWidth + 20);
          _GImageBox->_Height(bmpHeight + 20);
          _GImageBox->Left = (Screen->Width/2 - _GImageBox->Width/2);
          _GImageBox->Top  = (Screen->Height/2 - _GImageBox->Height/2);

          _GImageBox->_Border(true);

          _GImageBox->_ImageX(10);
          _GImageBox->_ImageY(10);
          _GImageBox->_ImageWidth(bmpWidth);
          _GImageBox->_ImageHeight(bmpHeight);

          _GImageBox->_Image(imagePathNameExt.c_str(), true, true);

          _GImageBox->_BorderColor(clRed);
          _GImageBox->_BackColor(clLime);

          _GImageBox->_EVENT_Click      = GImgBox_EVENT_Click;
          _GImageBox->_EVENT_Down       = GImgBox_EVENT_Down;
          _GImageBox->_EVENT_Up         = GImgBox_EVENT_Up;
          _GImageBox->_EVENT_MouseEnter = GImgBox_EVENT_MouseEnter;
          _GImageBox->_EVENT_MouseLeave = GImgBox_EVENT_MouseLeave;

      //}

      _GImageBox->Visible = true;

  //}
  
*/

/*
  //[Ÿ̸ Ȱȭ]
  //{
      GTimer_CopyEx *timer_CopyEx;
      timer_CopyEx = new GTimer_CopyEx();

  //}

*/


/*
  main_Form->vmos_OpenDialog->Options.Clear ();
  main_Form->vmos_OpenDialog->Options << ofHideReadOnly << ofAllowMultiSelect << ofEnableSizing;

  main_Form->vmos_OpenDialog->Execute();

  if(main_Form->vmos_OpenDialog->Options.Contains(ofAllowMultiSelect) == true)
  {
    ShowMessage("߼!!!");

  }
  else
  {
    ShowMessage("ϼ!!!");

  }

  main_Form->vmos_OpenDialog->Options.Clear ();
  main_Form->vmos_OpenDialog->Options << ofHideReadOnly << ofEnableSizing;

  main_Form->vmos_OpenDialog->Execute();

  if(main_Form->vmos_OpenDialog->Options.Contains(ofAllowMultiSelect) == true)
  {
    ShowMessage("߼!!!");

  }
  else
  {
    ShowMessage("ϼ!!!");

  }

*/


  //ShowMessage(main_Form->vmos_OpenDialog->Files->Strings[0] + "#");
  //ShowMessage(main_Form->vmos_OpenDialog->Files->Text + "#");


  /*
  main_Form->vmos_OpenDialog->Options.Clear ();
  main_Form->vmos_OpenDialog->Options << ofHideReadOnly << ofEnableSizing;

  main_Form->vmos_OpenDialog->Execute();
  */


  /*
  bool result = false;

  result = Files_MoveEx("C:\\Users\\AMD\\Downloads\\12 Strong(2018).mp4\r\n"
                        "D:\\@WD3T()\\Orbiter 9(2017).mp4",
                        "F:\\ \\Ȯ\\()12 Strong(2018).mp4\r\n"
                        "F:\\ \\Ȯ\\()Orbiter 9(2017).mp4",
                        true,
                        true);

  if(result == true) ShowMessage("");
  else               ShowMessage("");
  return;
  */

  /*
  bool result = false;

  result = Files_CopyEx("C:\\Users\\AMD\\Downloads\\12 Strong(2018).mp4\r\n"
                        "D:\\@WD3T()\\Orbiter 9(2017).mp4",
                        "F:\\ \\Ȯ\\()12 Strong(2018).mp4\r\n"
                        "F:\\ \\Ȯ\\()Orbiter 9(2017).mp4",
                        true,
                        true);

  if(result == true) ShowMessage("");
  else               ShowMessage("");
  return;
  */

  /*
  bool result = false;

  //[]   ʴ´(ϸ ).
  result = File_CopyEx("D:\\@WD3T()\\",
                       "F:\\ \\",
                       true,
                       true);

  if(result == true) ShowMessage("");
  else               ShowMessage("");
  return;
  */


  /*
  bool result = false;

  result = Dir_MoveEx("D:\\@WD3T()\\",
                      "F:\\ \\",
                      true,
                      true);

  if(result == true) ShowMessage("");
  else               ShowMessage("");

  return;
  */


  /*
  bool result = false;

  result = RemoveDir("D:\\@WD3T()\\(@)\\Space Cowboys(2000)\\ \\");

  if(result == true) ShowMessage("");
  else               ShowMessage("");
  */

  /*
  bool result = false;

  result = DirectoryExists((AnsiString)("D:\\@WD3T()\\(@)\\Space Cowboys(2000)\\"));

  if(result == true) ShowMessage("ߺ!!!");
  else               ShowMessage("ġ ");
  */


  /*
  bool result = false;

  result = Dir_IsEmpty("F:\\ \\(@)\\Space Cowboys(2000)\\");

  if(result == true) ShowMessage("");
  else               ShowMessage("");
  */




  /*
  bool result = false;

  result = File_MoveEx("D:\\@WD3T()\\(@)\\Orbiter 9(2017)\\Orbiter 9(2017).mp4",
                       "F:\\ \\Orbiter 9(2017).mp4",
                       true,
                       false);

  return;
  */


  /*
  bool result = false;

  result = Dir_CopyEx("D:\\@WD3T()\\",
                      "F:\\ \\",
                      false,
                      true);

  if(result == true) ShowMessage("");
  else               ShowMessage("");
  return;
  */

  
  /*
  bool result = false;

  result = File_CopyEx("F:\\(e)\\a.mp4",
                       "C:\\Users\\AMD\\Downloads\\a.mp4",
                       false,
                       true);

  if(result == true) ShowMessage("");
  else               ShowMessage("");

  return;
  */
  
  /*
  Dir_Copy("F:\\ \\",
           "D:\\@WD3T()\\(@)\\@Avatar\\");

  return;

  */


  /*
  File_MoveEx("F:\\(e)\\ \\a.mp4",
              "C:\\Users\\AMD\\Downloads\\a.mp4",
              true,
              true);
  */


/*

  //[2020.09.30.][߰]
  //{
      //[2020.09.30.][߰]

      //[VAR]
      //{
          GProgressDialog  *_GProgressDialog;

          int  t, i;

      //}

      //<GProgressDialog> Ȯ Ѱ.
      _GProgressDialog = new GProgressDialog();


      _GProgressDialog->_Mode_Multi();


      _GProgressDialog->_Visible(true);


      _GProgressDialog->_TotalProgress_Min(0);
      _GProgressDialog->_TotalProgress_Max(10);
      _GProgressDialog->_TotalProgress_Progress(0);

      for(t = 0; (t < 10) && (_GProgressDialog->_IsVisible()); )
      {

        _GProgressDialog->_OneProgress_Min(0);
        _GProgressDialog->_OneProgress_Max(100);
        _GProgressDialog->_OneProgress_Progress(0);

        for(i = 0; (i < 100) && (_GProgressDialog->_IsVisible()); )
        {
          i++;
          _GProgressDialog->_OneProgress_Progress(i);

          Application->ProcessMessages();

          Sleep(10);

        }

        if(t == 4)
        {
          _GProgressDialog->_Mode_Single();
          Application->ProcessMessages();

        }

        t++;
        _GProgressDialog->_TotalProgress_Progress(t);
        Application->ProcessMessages();

      }


      delete _GProgressDialog;

  //}


*/











  //}



  //[VAR]
  //{
      //struct FONTRESOURCE  *fontresource;

  //}

  //[ڵ]
  //{
      //FONTRESOURCE_GetHandle(&fontresource);

  //}

  //[⺻ȯ ]
  //{
      //[2010.02.04.][߰!!!]{----------------------------
      //  ⺻ ǹǷ   ־ Ѵ.
      //}----------------------------------------------------

      //GPART_GVmos_Create();

  //}

  //[ǰ ]
  //{
      /*
      GPART_GBalloonBox_Create();

      GPART_GHint_Create();

      GPART_GMsgBox_Create();

      GPART_GFindDialog_Create();
      */

  //}

  //[GVmos]
  //{
      /*
      GPART_GVmos_GetPtr(&_GVmos);

      _GVmos->Visible = true;
      _GVmos->_baseForm->SetFocus();

      //_GVmos->_BackColor(clGray);

      //_GVmos->_CaptionBackColor(clYellow);
      //_GVmos->_CaptionFontColor(clLime);
      //_GVmos->_CaptionFontStyle(d_FONTSTYLE_bold);
      //_GVmos->_BackColor(clYellow);
      */

  //}

  //[GForm]
  //{

      /*
      _GForm          = new TGForm_Form(NULL);
      //_GForm->Parent  = _GVmos->_baseForm;

      _GForm->_Width(550);
      _GForm->_Height(350);

      //ȭ ߰ ġϰ .
      _GForm->_Left(Screen->Width/2 - _GForm->Width/2);
      _GForm->_Top(Screen->Height/2 - _GForm->Height/2);

      _GForm->Visible = true;

      //_GForm->_BorderColor(clRed);
      //_GForm->_OutLineColor(clRed);
      _GForm->_BackColor(clRed);
      //_GForm->_CaptionFontColor(clLime);
      //_GForm->_CaptionFontStyle(d_FONTSTYLE_bold);

      _GForm->_Caption("::: ̳ ߿ :::");

      _GForm->_FormDesignMode(true);
      */

  //}

}


