

//[VMOSǼ][2010.12.09.][!!!]{------------------------------------
//VMOS  [ API]  յǰ, پ API  ϱ Ͽ API  
//VMOS  ȭ Ǿ   ǹǷ VMOS ũ _ROM_ ũ 
//ǹǷ   [ü ] ȭ Ͽ  Ҽ ֵ Ѵ.
//
//˵ VMOS ü ó <vmos_memmap_def.h>   ʰ ⼭ ǵ
//[ü ]  Ѵ.
//}------------------------------------------------------------------------------


#ifndef vmos_info_h
#define vmos_info_h


#include  "vmos_def.h"


//[˵ ü  з]
//{
    //[2010.12.10.][߰!!!]{--------------------
    //[VMOS 迭]            : 0xffffffff:xxxxxxxx
    //[VMOS:AT45DB041X 迭] : 0x45db0410:xxxxxxxx
    //[OSX 迭]             : 0x00000000:xxxxxxxx
    //
    // 4Byte  Ѵ.
    //}--------------------------------------------

    #define  d_OS_vmos          0xffffffff00000000
    #define  d_OS_at45db041x    0x45db041000000000
    #define  d_OS_osx           0x0000000000000000

//}






struct  VMOSINFO
{
  //[2010.12.09.][!!!]{------------------------------------------------------------
  //˵ ġ VMOS  ڼ  Ѵ.
  //ġǴ VMOS   ణ ̰  ̸  ϱ  ̴.
  //}------------------------------------------------------------------------------------

  //[޸ ]
  //{
      DTU4  mcuFlash_Base; //0x00000000
      DTU4  mcuFlash_Size; //(1024*64)

      DTU4  mcuRam_Base; //0x20000000
      DTU4  mcuRam_Size; //(1024*20)

      //˵(VMOS ü) ϴ SRAM .
      DTU4  mcuVmosRam_Base; //d_McuRam_Base
      DTU4  mcuVmosRam_Size; //(1024*4)

  //}

  //[ κ CODE:BASE ]
  //{
      DTU4  codeBase_BaseVM; //d_McuFlash_Base
      DTU4  codeSize_BaseVM; //(1024*4)

      DTU4  codeBase_System; //(d_CodeBase_BaseVM + d_CodeSize_BaseVM)
      DTU4  codeSize_System; //(1024*1)

      //<System:1KByte>  ġȴ.
      DTU4  codeBase_VMOS; //(d_CodeBase_System + d_CodeSize_System)
      //  VMOS 迭 VMOS:AT45DB041X 迭  ũⰡ ޶.
      //ġ VMOS  <vmos.ginf> ȿ ũ   Ƿ   缳ȴ.
      DTU4  codeSize_VMOS; //1024*41       //[ũ(KByte ) ؼ ]

      //[VmosRom]
      //{
          //[2010.12.11.][!!!]{--------------------------------------------------
          //Ʒ   VMOS/VMOS:AT45DB041X 迭   ٸǷ ġÿ
          // Ͽ 缳ؾ Ѵ.
          //}--------------------------------------------------------------------------

          // Flash(ROM)  (⺻).
          DTU4  codeBase_VmosRom; //(d_CodeBase_VMOS + d_CodeSize_VMOS)
          DTU4  codeSize_VmosRom; //(d_McuFlash_Size - d_CodeBase_VmosRom)

      //}

      //[VmosRam]
      //{
          //[2009.08.12.][߰!!!]{--------------------------------------------
          //VMOS  ϴ SRAM  MCU  ġ.
          //RAM  [VMOS]  [VMOS:AT45DB041X]   ũ  Ѵ.
          //}--------------------------------------------------------------------

          //[0x20000000:0x20000fff]  4KByte  OS ü Ѵ.

          //VMOS  RAM  ġ OS ü ϴ SRAM    ũⰡ پ ִ.
          DTU4  codeBase_VmosRam; //(d_McuVmosRam_Base + d_McuVmosRam_Size)

          //SRAM  0x20000000  ϹǷ ̰ ־ Ѵ-------------v
          DTU4  codeSize_VmosRam; //(d_McuRam_Size - (d_CodeBase_VmosRam - d_McuRam_Base))

      //}

      //[VmosHeap]
      //{
          // [˵]    .

          // ʴ ּҸ ҴѴ.
          DTU4  codeBase_VmosHeap; //0xffffffff

          //  ʴ´.
          DTU4  codeSize_VmosHeap; //0

      //}

  //}


  //[System  ]
  //{
      //IDE ʿ  ּҸ ʿϴ.

      //[OS   ]
      //{
          //[!]{-------------------------------------------------------------------
          //[ȥ]  Ҷ  [ȥ]   ĺϴ 뵵 ȴ.
          //}----------------------------------------------------------------------

          DTU4  sys_OS_VMOS; //(d_CodeBase_System + 0x0000) //2Byte
          DTU4  sys_OS_BaseVM; //(d_CodeBase_System + 0x0002) //2Byte

      //}

      //[MCU  ּ]
      //{
          DTU4  codeBase_SystemMcu; //(d_Sys_OS_BaseVM + 2)


          //MCU  ġ Ѵ( 4Byte ũ⸦ ´).
          DTU4  sys_CodeBase_BaseVM; //(codeBase_SystemMcu + 4*0)  //4Byte
          DTU4  sys_CodeSize_BaseVM; //(codeBase_SystemMcu + 4*1)  //4Byte

          DTU4  sys_CodeBase_System; //(codeBase_SystemMcu + 4*2)  //4Byte
          DTU4  sys_CodeSize_System; //(codeBase_SystemMcu + 4*3)  //4Byte

          DTU4  sys_CodeBase_VMOS; //(codeBase_SystemMcu + 4*4)  //4Byte
          DTU4  sys_CodeSize_VMOS; //(codeBase_SystemMcu + 4*5)  //4Byte

          DTU4  sys_CodeBase_VmosRom; //(codeBase_SystemMcu + 4*6)  //4Byte
          DTU4  sys_CodeSize_VmosRom; //(codeBase_SystemMcu + 4*7)  //4Byte

          DTU4  sys_CodeBase_VmosRam; //(codeBase_SystemMcu + 4*8) //4Byte
          DTU4  sys_CodeSize_VmosRam; //(codeBase_SystemMcu + 4*9) //4Byte

          DTU4  sys_CodeBase_VmosHeap; //(codeBase_SystemMcu + 4*10) //4Byte
          DTU4  sys_CodeSize_VmosHeap; //(codeBase_SystemMcu + 4*11) //4Byte

      //}

      //[VMOS  ּ]
      //{
          //VMOS       ġʹ.
          //<d_Sys_VmosVarTable_Size> ü ũ-------------------v
          DTU4  codeBase_SystemVmos; //(d_Sys_CodeSize_VmosHeap + 4)


          //VMOS  ġ Ѵ( 8Byte ũ⸦ ´).
          DTU4  sys_RomStart;    //(d_CodeBase_SystemVmos + 8*0)  //8Byte
          DTU4  sys_RomEnd;      //(d_CodeBase_SystemVmos + 8*1)  //8Byte

          DTU4  sys_RamStart;    //(d_CodeBase_SystemVmos + 8*2)  //8Byte
          DTU4  sys_RamEnd;      //(d_CodeBase_SystemVmos + 8*3)  //8Byte

          DTU4  sys_HeapStart;   //(d_CodeBase_SystemVmos + 8*4)  //8Byte
          DTU4  sys_HeapEnd;     //(d_CodeBase_SystemVmos + 8*5)  //8Byte

          //  <F:adr>   ϴ VMOS ȿ  MCU  ּ  ϱ  ּҿ̴.
          DTU4  sys_SystemStart; //(d_CodeBase_SystemVmos + 8*6)  //8Byte
          DTU4  sys_SystemEnd;   //(d_CodeBase_SystemVmos + 8*7)  //8Byte

          //[OS ]
          //{
              //[!]{------------------------------------------------------------------------------
              // [ü(VMOS/OSX)]  <*.gos>  ġ  <*.ginf>   {ĺ} 
              //а, ˵  <sys_OS_X>  ,  ˵ ġ [ü]  
              //ϰ ˼ִ.
              //}---------------------------------------------------------------------------------

              DTU4  sys_OS_ID; //(d_CodeBase_SystemVmos + 8*8)  //8Byte

          //}

      //}

  //}

  //[޸ ][˵]
  //{
      DTU8  VMOS_RamSize; //d_CodeSize_VmosRam

      //[VMOS  ּ  ]
      //{
          //[!]{--------------------------------------------------------------
          //VMOS 迭, VMOS:AT45DB041X 迭   ޶.
          //ġ ش VMOS  ° 缳 ؾ Ѵ.
          //}-----------------------------------------------------------------

          //[ROM]
          DTU8  VMOS_ROM_START;    //0x0000000000000000
          DTU8  VMOS_ROM_END;      //(d_VMOS_ROM_START + d_CodeSize_VmosRom - 1)

          //[RAM]
          DTU8  VMOS_RAM_START;    //(d_VMOS_ROM_END + 1)
          DTU8  VMOS_RAM_END;      //(d_VMOS_RAM_START + d_CodeSize_VmosRam - 1)

          //[HEAP]
          // ׳ [RAM]  ٷ  ۵Ǿ 64KByte ũ⸦    ´.
          DTU8  VMOS_HEAP_START;   //(d_VMOS_RAM_END + 1)
          //[2009.08.17.][!!!]
          //  Ƿ    [ּ]    ҴѴ.
          DTU8  VMOS_HEAP_END;     //d_VMOS_HEAP_START

          //[SYSTEM]
          //[ġ]    ִ [ּҿ] ̵ȴ.
          DTU8  VMOS_SYSTEM_START; //0xffffffff00000000
          DTU8  VMOS_SYSTEM_END;   //0xffffffffffffffff

      //}

  //}

  //[ΰ ]
  //{
      //˵ Flash   [ʼ]  Ѵ.
      //BaseVM(4K)   64K     شȴ.
      DTU4  vmosInfo_ErasePageNum; //60


  //}

  //[ ġϴ ü ĺ]
  //{
      //[2010.12.10.][߰!!!]{----------------------------------------------------------------
      // ġϴ [ü]  VMOS, VMOS:AT45DB041X, OSX 迭  
      //ٸ  ˱  ̴.
      //   [ü]  ġϴ <matdol.cpp>  ش Լ鿡 ϰ ȴ.
      //
      //ݵ ġ  ̰  ġϴ [ü <ĺ>]  ݵ ؾ Ѵ.
      //}----------------------------------------------------------------------------------------

      DTU8  osID; //(BASE : 0xffffffff00000000) ⺻ VMOS   ش.

  //}


};


//[2010.12.10.][Ϸ!!!]
void __fastcall VmosInfo_GetPtr(struct VMOSINFO  **rVmosInfo);

//[2010.12.10.][Ϸ!!!]
void __fastcall VmosInfo_Init(void);

//[2010.12.11.][Ϸ!!!]
void __fastcall VmosInfo_CodeSize_VMOS(//[2010.12.11.][߰!!!]{---------------------------------
                                       //VMOS:AT45DB041X 迭  Ϻ ٸ  ʿϹǷ
                                       //̸ Ҽ ֵ [ĺ]  ߰Ѵ.
                                       //}---------------------------------------------------------
                                       DTU8  pID,
                                       DTU4  pCodeSize_VMOS);



#endif
