

//[2009.07.07.ȭ][!!!]

#ifndef combus_h
#define combus_h


//[ComBus]
//{
    //[⺻]{----------------------------------------------------------------
    //
    //BYTE :           1           8    2^SIZE
    //BIT  :     7   6  4:5 3:0
    //       { [W/R.T/S.AK.SIZE] [ּ] [ڷ] }
    //
    //[μ]
    //
    //[W/R] Bit7
    // - Write(0)
    // - Read(1)
    //
    //[T/S] Bit6
    // - Type(1)   : 1, 2, 4, 8  C-Type  ѹ б/ ϴ .
    //               Ϲ MCU  ġ  ϴ  ȴ.
    //
    // - Stream(0) : Ϲ Ǵ .
    //
    //[AK] Bit[5:4]
    // - VMOS(10) : VMOS  64Bit ּҸ  Ѵ.
    // - MCU(01)  : MCU  ּҸ  Ѵ.
    // - BUS(00)  : [Ĺ]  ּ(ȣ)  Ѵ.
    //
    //[SIZE] Bit[3:0]
    // - 2^SIZE   ũ⸦ Ҽ ִ(1<<SIZE  ).
    // - , 4bit   ũ  ǥϱ Ͽ []  ũ Ѵ.
    // - ũ = 1 << SIZEl;   Ҽ ִ.
    // - 1 Byte - 32 KByte  ǥ ϴ.
    //
    //[ּ]
    // -  8 Byte ũ⸦ ´.
    // - [AK]   ٸ ǹ̸ ´.
    //
    //[ڷ]
    // - 2^SIZE  ũ⸦  ڷ῭.
    //
    //}--------------------------------------------------------------------------

    //[]{***********************************
    //                            size                                 
    //         1           8     2
    // { [W.T/S.AK.SIZE] [ּ] [ڷ] } 
    //                                   [ACK]
    //
    //[б]************************************
    //                            size                                 
    //         1           8     2           
    // { [R.T/S.AK.SIZE] [ּ]      
    //                          [ڷ] } [ACK]
    //
    //}*****************************************

    //[]
    //{
        //[CTB]
        //{
            // BITMASK   .
            #define  d_CB_WR      0x80  
            #define  d_CB_TS      0x40  
            //{
                #define  d_CB_TS_T    0x40 
                #define  d_CB_TS_S    0x00 
                 
            //}
            
            #define  d_CB_AK      0x30  
            //{
                #define  d_CB_AK_V    0x20 
                #define  d_CB_AK_M    0x10 
                #define  d_CB_AK_B    0x00 

            //}

            #define  d_CB_SIZE    0x0f  
            //1Byte - 32KByte  ѹ  ϴ.

        //}

        //[帧]
        //{
            #define  d_CBFW_ACK     0xac  //[Ź] ü ó Ϸ.
            #define  d_CBFW_EOR     0xe0  //ó .

            //[2009.12.09.][߰!!!]
            #define  d_CBFW_FEOR    0xfe  //ġ ó (STM32 ü  ),

            #define  d_CBFW_NULL    0x00  //ǹ̾.

            //[2009.07.14.ȭ][߰!!!]
            #define  d_CBFW_BRK     0xbe  // <Break>.

            //[2009.07.18.][߰!!!]{----------------------------
            //[䵹]  [Ź]   ó  Ѵ.
            //[ROM  Ϸ]  .
            #define  d_CBFW_FIN     0xf1  //óϷ <Finish>.
            //}----------------------------------------------------

        //}

        #define  d_CB_Write   0
        #define  d_CB_Read    1

    //}
    
//}

//------------------------------------------------------------------------------
//[Լ]------------------------------------------------------------------------
//------------------------------------------------------------------------------

//[2011.07.25.][Ϸ!!!]
bool __fastcall ComBus_Error(void);

//[2009.08.01.][Ϸ!!!]
bool __fastcall ComBus_FwByte_Read(//Ȯ [帧Ʈ].
                                   unsigned char  pFwByte,
                                   //[ð] .
                                   int            pTimeOut);

//[2009.07.30.][Ϸ!!!]
bool __fastcall ComBus_FwByte_Check(unsigned char  pFwByte);


//[2009.08.01.][Ϸ!!!]
bool __fastcall ComBus_Write(unsigned char        pTS,
                             unsigned char        pAK,
                             unsigned char        pSizeExp,
                             unsigned long long   pAdr,
                             unsigned char       *pStream);

//[2009.08.08.][Ϸ!!!]
void __fastcall ComBus_Write2(unsigned char        pTS,
                              unsigned char        pAK,
                              unsigned char        pSizeExp,
                              unsigned long long   pAdr,
                              unsigned char       *pStream);

//[2009.08.01.][Ϸ!!!]
bool __fastcall ComBus_Read(unsigned char        pTS,
                            unsigned char        pAK,
                            unsigned char        pSizeExp,
                            unsigned long long   pAdr,
                            unsigned char       *pStream);



//[2011.07.25.][Ϸ!!!]
bool __fastcall ComBus_TimeOut_FwByte(// [帧Ʈ] .
                                      unsigned char  pFwByte,
                                      //[ð] .
                                      int            pTimeOut);

//[2011.07.25.][Ϸ!!!]
bool __fastcall ComBus_TimeOut_ReadX(//о .
                                     int  pReadCount,
                                     //[ð] .
                                     int  pTimeOut);



//}


#endif